<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="de" xml:lang="de">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <meta name="author" content="Günter Quast, Juli 2022 (letzte Änderung Nov. 2023)" />
  <title>Datenauswertung in Grundlagenpraktika zur Physik</title>
  <style>
    html {
      line-height: 1.5;
      font-family: Georgia, serif;
      font-size: 20px;
      color: #1a1a1a;
      background-color: #fdfdfd;
    }
    body {
      margin: 0 auto;
      max-width: 36em;
      padding-left: 50px;
      padding-right: 50px;
      padding-top: 50px;
      padding-bottom: 50px;
      hyphens: auto;
      overflow-wrap: break-word;
      text-rendering: optimizeLegibility;
      font-kerning: normal;
    }
    @media (max-width: 600px) {
      body {
        font-size: 0.9em;
        padding: 1em;
      }
      h1 {
        font-size: 1.8em;
      }
    }
    @media print {
      body {
        background-color: transparent;
        color: black;
        font-size: 12pt;
      }
      p, h2, h3 {
        orphans: 3;
        widows: 3;
      }
      h2, h3, h4 {
        page-break-after: avoid;
      }
    }
    p {
      margin: 1em 0;
    }
    a {
      color: #1a1a1a;
    }
    a:visited {
      color: #1a1a1a;
    }
    img {
      max-width: 100%;
    }
    h1, h2, h3, h4, h5, h6 {
      margin-top: 1.4em;
    }
    h5, h6 {
      font-size: 1em;
      font-style: italic;
    }
    h6 {
      font-weight: normal;
    }
    ol, ul {
      padding-left: 1.7em;
      margin-top: 1em;
    }
    li > ol, li > ul {
      margin-top: 0;
    }
    blockquote {
      margin: 1em 0 1em 1.7em;
      padding-left: 1em;
      border-left: 2px solid #e6e6e6;
      color: #606060;
    }
    code {
      font-family: Menlo, Monaco, 'Lucida Console', Consolas, monospace;
      font-size: 85%;
      margin: 0;
    }
    pre {
      margin: 1em 0;
      overflow: auto;
    }
    pre code {
      padding: 0;
      overflow: visible;
      overflow-wrap: normal;
    }
    .sourceCode {
     background-color: transparent;
     overflow: visible;
    }
    hr {
      background-color: #1a1a1a;
      border: none;
      height: 1px;
      margin: 1em 0;
    }
    table {
      margin: 1em 0;
      border-collapse: collapse;
      width: 100%;
      overflow-x: auto;
      display: block;
      font-variant-numeric: lining-nums tabular-nums;
    }
    table caption {
      margin-bottom: 0.75em;
    }
    tbody {
      margin-top: 0.5em;
      border-top: 1px solid #1a1a1a;
      border-bottom: 1px solid #1a1a1a;
    }
    th {
      border-top: 1px solid #1a1a1a;
      padding: 0.25em 0.5em 0.25em 0.5em;
    }
    td {
      padding: 0.125em 0.5em 0.25em 0.5em;
    }
    header {
      margin-bottom: 4em;
      text-align: center;
    }
    #TOC li {
      list-style: none;
    }
    #TOC ul {
      padding-left: 1.3em;
    }
    #TOC > ul {
      padding-left: 0;
    }
    #TOC a:not(:hover) {
      text-decoration: none;
    }
    code{white-space: pre-wrap;}
    span.smallcaps{font-variant: small-caps;}
    span.underline{text-decoration: underline;}
    div.column{display: inline-block; vertical-align: top; width: 50%;}
    div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
    ul.task-list{list-style: none;}
  </style>
  <script
  src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js"
  type="text/javascript"></script>
  <!--[if lt IE 9]>
    <script src="//cdnjs.cloudflare.com/ajax/libs/html5shiv/3.7.3/html5shiv-printshiv.min.js"></script>
  <![endif]-->
</head>
<body>
<header id="title-block-header">
<h1 class="title">Datenauswertung in Grundlagenpraktika zur Physik</h1>
<p class="author">Günter Quast, Juli 2022 (letzte Änderung
Nov. 2023)</p>
</header>
<head>
<style>
     body {
          margin-left:20px;
      <!-- text-align:justify; -->
      max-width:55em;
          font-family:Helvetica, Sans-Serif;
          color:black;
          background-color:White;
     }
  </style>
</head>
<p> </p>
<hr />
<h2
id="hinweise-zur-datenauswertung-in-den-physikalischen-praktika">Hinweise
zur Datenauswertung in den physikalischen Praktika</h2>
<hr />
<p> </p>
<p> </p>
<p>In den Praktika zur Physik führen Sie selbständig Experimente zur
Überprüfung einfacher physikalischer Modelle durch. Dabei untersuchen
Sie physikalische Phänomene mit unterschiedlichen Messgeräten und
Messmethoden, werten die resultierenden Daten aus und dokumentieren die
Ergebnisse so, dass sie aus den Aufzeichnungen reproduzierbar sind.</p>
<p>Die Qualifikationsziele der Anfängerpraktika Physik sind im
Modulhandbuch beschrieben:</p>
<ul>
<li>Beherrschung unterschiedlicher Messgeräte und Messmethoden,</li>
<li>Erfassung und Darstellung experimenteller Daten,</li>
<li>Analyse der Daten und Durchführung der Fehlerrechnung,</li>
<li>Erstellung eines Messprotokolls.</li>
</ul>
<p>Diese Anleitung gibt eine Übersicht über Grundlagen, empfohlene
Software-Werkzeuge und Vorgehensweisen zur <strong>Datenauswertung in
der physikalischen Praktika</strong>.</p>
<p> </p>
<p>Allgemein ist das Ziel der Datenanalyse in der Physik zu überprüfen,
ob ein angenommenes Modell durch die experimentellen Daten im <u>Rahmen
von deren Unsicherheiten</u> adäquat beschrieben wird. Dazu müssen
zunächst die Unsicherheiten der Ausgangsmessungen quantifiziert werden.
Anschließend werden unter Annahme der Gültigkeit des Modells freie
Modellparameter und deren aus den Unsicherheiten der Messdaten
resultierende Unsicherheiten bestimmt. Früher nannte man diesen letzten,
meist mit analytischen Näherungsrechnungen durchgeführten Schritt der
Bestimmung der Parameterunsicherheiten “Fehlerrechnung”. Mit der
allgemeinen Verfügbarkeit von Computern mit ausreichend Rechenleistung
werden in der modernen Datenauswertung numerische Verfahren zu Anpassung
von Modellfunktionen an die Messdaten verwendet, die sowohl die
Überprüfung der Gültigkeit der Modellhypothese als auch die Bestimmung
der besten Parameterwerte und deren Unsicherheiten erlauben.</p>
<h1 id="inhalt">Inhalt:</h1>
<blockquote>
<p><a href="#Chapter01">1 Übersicht: Die einzelnen Schritte der
Datenauswertung</a><br />
<a href="#Chapter02">2 Grundsätzliches zum Messprozess</a><br />
<a href="#Chapter03">3 Wichtige Grundlagen der Statistik</a></p>
</blockquote>
<blockquote>
<p><a href="#Appendix"><strong>Anhang</strong></a><br />
<a href="#AppendixA1">A1 Übersicht: Hilfsmittel für die physikalischen
Praktika</a><br />
<a href="#AppendixA2">A2 Empfehlungen zur praktischen
Vorgehensweise</a><br />
<a href="#AppendixA3">A3: Arbeiten mit <em>Jupyter
Notebooks</em></a><br />
<a href="#AppendixA4">A4: Tipps für MS Windows</a></p>
</blockquote>
<p> </p>
<p> </p>
<h2 id="übersicht-die-einzelnen-schritte-der-datenauswertung">1
Übersicht: Die einzelnen Schritte der Datenauswertung</h2>
<p><a name="Chapter01"></a></p>
<p>  <strong>1. Quantifizierung der Unsicherheiten aller eingehenden
Messgrößen</strong></p>
<blockquote>
<p>Die Unsicherheiten der relevanten Messgrößen entnehmen Sie entweder
den Datenblättern der verwendeten Messgeräte, oder Sie führen die
gleiche Messung mehrmals aus und bestimmen die Unsicherheiten aus der
Streuung der erhaltenen Ergebnisse als Standardabweichung <span
class="math inline">\(\sigma\)</span> der resultierenden
Häufigkeitsverteilung. Mit einiger Erfahrung ist es auch möglich, die
Unsicherheiten für typische Messvorgänge zuverlässig zu schätzen.</p>
</blockquote>
<p>  <strong>2. Durchführung der Messung</strong></p>
<blockquote>
<p>Als nächstes wird eine Messreihe, üblicherweise als Wertepaare (<span
class="math inline">\(x_i, y_i\)</span>), aufgenommen. Diese sollten in
einer Datei im Textformat abgelegt werden, damit sie sowohl von Menschen
als auf von Computerprogrammen gelesen werden können. Wichtig ist die
sorgfältige Protokollierung auch der sogenannten “Metadaten”, die den
Ursprung und die Bedeutung der Messdaten dokumentieren. Es ist ratsam,
schon in diesem ersten Schritt eine grafische Darstellung der Daten zur
visuellen Kontrolle des Messprozesses zu erstellen. Einfache Fehler bei
der Aufnahme der Messreihe können Sie dabei unmittelbar entdecken.</p>
</blockquote>
<p>  <strong>3. Anpassung eines Modells an die Messdaten</strong></p>
<blockquote>
<p>Die Daten und eine oder mehrere Modellhypothese(n) werden verglichen.
In der Regel enthält die Modellhypothese noch freie Parameter, und
außerdem ist das Modell in der Regel “überbestimmt”, d.h. es gibt mehr
Datenpunkte, als zur Bestimmung der freien Parameter notwendig sind. In
solchen Fällen werden in einem Anpassungsschritt die optimalen Werte der
freien Parameter bestimmt, die den kleinsten “Abstand” zwischen den
Werten der Modellfunkton <span class="math inline">\(f_i=f(x_i, a_1,
..., a_{n_p})\)</span> mit <span class="math inline">\(n_p\)</span>
Parametern <span class="math inline">\(a_i\)</span> und den <span
class="math inline">\(N\)</span> Messwerten <span
class="math inline">\(y_i\)</span> ergeben. Als Abstandsmaß wird dabei
üblicherweise die von Carl Friedrich Gauß vorgeschlagene Summe <span
class="math inline">\(S\)</span> der Residuenquadrate (“Summe der
kleinsten Fehlerquadrate”) verwendet:</p>
</blockquote>
<blockquote>
<p><span class="math inline">\(S=\displaystyle \sum_i^N {
\left(\frac{f_i-y_i}{\sigma_i} \right)}^2\)</span>.</p>
</blockquote>
<p>  <strong>4. Überprüfung der Gültigkeit der
Modellhypothese</strong></p>
<blockquote>
<p>Als Ergebnisse des Anpassungsalgorithmus erhalten Sie den Wert <span
class="math inline">\(S_0\)</span> der Summe der Residuenquadrate am
Optimum der Parameterwerte, <span class="math inline">\(S_0(\hat{a}_1,
..., \hat{a}_{n_p})\)</span>. Wenn das Modell passt, sollten
Abweichungen rein statistischer Natur sein. Auf Grund der Definition der
Standardabweichung ist der Erwartungswert der quadrierten Abweichung
zwischen einer Messung und dem wahren Wert gleich Eins; für <span
class="math inline">\(S_0\)</span> am Optimum erwartet man also einen
Wert von <span class="math inline">\(N\)</span>, der Anzahl der
Messungen. Es muss allerdings berücksichtigt werden, dass die Daten im
Anpassungsprozess bereits genutzt wurden, um die <span
class="math inline">\(n_p\)</span> Parameterwerte zu optimieren. In
diesem Fall ist der erwartete Wert von <span
class="math inline">\(&lt;S_0&gt; = N - n_p = N_f\)</span> (Zahl der
Freiheitsgrade).</p>
</blockquote>
<p>  <strong>5. Extraktion der Modellparameter und von deren
Unsicherheiten</strong></p>
<blockquote>
<p>Wenn die Modellhypothese nicht verworfen wurde, werden im letzten
Schritt die Modellparameter bestimmt. Die optimalen Parameterwerte
wurden bereits im vorangegangenen Schritt vorausgesetzt - bestimmt
werden müssen noch die Parameterunsicherheiten. Diese ergeben sich aus
der Verlauf des Wertes von <span class="math inline">\(S\)</span> in der
Nähe des Minimums <span class="math inline">\(S_0\)</span>. Das
Verfahren wird weiter unten ausführlich erläutert.</p>
</blockquote>
<h2 id="grundsätzliches-zum-messprozess">2 Grundsätzliches zum
Messprozess</h2>
<p><a name="Chapter02"></a></p>
<p>Im <strong>Messprozess</strong> werden Daten in einer sehr genau
kontrollierten physikalischen Umgebung bestimmt; dies wird als Versuch
oder auch Experiment bezeichnet. Der Messprozess liefert Zahlenwerte,
die mit Werten aus Vorhersagen verglichen werden, um Aussagen über die
Gültigkeit theoretischer Modelle machen zu können.</p>
<p><strong>Messen heißt</strong> dabei grundsätzlich, eine physikalische
Größe mit einer Referenzgröße, einer Maßeinheit, zu
<strong>vergleichen</strong>. Dabei kann ein direkter Vergleich
durchgeführt werden - z.B. die Länge eines Objekts mit einem Maßstab
oder eine elektrische Spannung mit einer Spannungsreferenz. Häufig
werden Messungen auch indirekt durchgeführt, indem eine präzise bekannte
und gut überprüfte Annahme verwendet wird, z.B. eine Längenmessung über
die Laufzeit von Licht oder eine Strommessung mit Hilfe des ohmschen
Gesetzes.</p>
<p>Beim <strong>Messprozess</strong> werden Eingangsgrößen in
Messsignale gewandelt, aus denen die Messgrößen gewonnen wird. Diese
Messgrößen werden schließlich mit einer Modellannahme verglichen, um die
Ergebnisgröße(n) zu erhalten. Ein Beispiel ist die Bestimmung der
Erdbeschleunigung als Ergebnisgröße aus der Ausdehnung einer Feder mit
bekannter Federkonstanten als Messgröße bei Anhängen einer
Referenzmasse. Heute werden Messgrößen fasst ausnahmslos als elektrische
Signale erfasst, die in Analog-Digital-Wandlern in Zahlenwerte umgesetzt
und dann als digitale Daten weiter verarbeitet werden.</p>
<p>Alle Messgrößen sind von unvermeidbaren
<strong>Unsicherheiten</strong> betroffen, die die wahren Werte der
Größen überlagern und diese damit zufällig verändern. Bei einem
Messergebnis handelt es sich also um eine “Schätzung” des wahren Wertes
im Sinne der Statistik, deren Unsicherheit immer zusätzlich angegeben
werden muss:</p>
<p><span class="math inline">\(m = (\hat{m} \pm \sigma_m)
[m]\,\)</span>.</p>
<p>Dabei ist <span class="math inline">\(\hat{m}\)</span> der
Schätzwert, <span class="math inline">\(\sigma_m\)</span> die
Unsicherheit auf den Schätzwert, und <span
class="math inline">\([m]\)</span> ist die Einheit der Messgröße. Die
Angabe eines Messergebnisses ohne Unsicherheit und Einheit ist, wie
unten genauer erläutert wird, praktisch wertlos!</p>
<p>Häufig werden Unsicherheiten auch als dimensionslose
<strong>relative</strong> Unsicherheiten angegeben,</p>
<p><span class="math inline">\(\sigma_m^{(R)} =
\frac{\sigma_m}{m}\,\)</span>.</p>
<p>Werden mehrere Messgrößen aufgenommen, so sind viele der dabei
auftretenden Unsicherheiten (statistisch) unabhängig voneinander, d.h.
die Änderung einer der Messgröße im Rahmen ihrer Unsicherheiten ändert
die Werte anderer Messgrößen nicht. Solche Unsicherheiten werden als
“statistische Unsicherheiten” bezeichnet. Sie können durch
<strong>mehrfache Messung</strong> bestimmt und reduziert werden.</p>
<p>Es gibt bei Messungen aber fast immer auch Effekte, die alle
Messwerte gleichermaßen betreffen, also nicht unabhängig sondern
<strong>korreliert</strong> sind. Beispiele sind die
Kalibrationsunsicherheiten der verwendeten Messgeräte, z.B. ein auf
Grund von Temperatureffekten zu langer oder zu kurzer Maßstab oder eine
nicht ganz korrekte Spannungsreferenz. Andere Quellen solcher
Unsicherheiten sind als klein angenommene, vernachlässigte
Umgebungseffekte wie Reibung oder Luftwiderstand bei mechanischen
Versuchen, oder oft nicht vermeidbare Näherungen in den verwendeten
theoretischen Modellen. Solche korrelierten Unsicherheiten werden als
“systematische Unsicherheiten” bezeichnet. Systematische Unsicherheiten
können durch Mehrfachmessung nicht reduziert werden. Häufig gibt es zur
Bestimmung systematischer Unsicherheiten lediglich Konventionen, aber
keine allgemein gültigen oder anerkannten Verfahren.</p>
<p>Die Angabe eines Messergebnisses ohne Unsicherheit ist praktisch
wertlos, denn die Überprüfung der Übereinstimmung einer Messung mit
einer theoretischen Erwartung ist nur im Rahmen der Unsicherheiten
möglich. Bei dieser Bewertung handelt es sich aus Sicht der Statistik um
einen <strong>Hypothesentest</strong>. Ein Messergebnis wird grafisch
dargestellt als Messpunkt mit “Fehlerbalken”, der die Größe der
Unsicherheit symbolisiert. Wir nehmen dazu an, dass die Messwerte aus
einer Messreihe mit unabhängigen Messungen unter identischen Bedingungen
gaußförmig um ihren Mittelwert verteilt sind (“gaußförmige
Unsicherheit”), eine Begründung dazu wird in <a
href="#Chapter03">Kapitel 3</a> gegeben. In der Physik verwenden wir die
Konvention, dass die Länge des Fehlerbalkens zwei Standardabweichungen
<span class="math inline">\(\sigma\)</span> dieser Gaußverteilung
entspricht. Innerhalb des Intervalls [m-<span
class="math inline">\(\sigma\)</span>, m+<span
class="math inline">\(\sigma\)</span>] liegen damit 68,3% der
Messwerte.</p>
<blockquote>
<p>Ein <strong>Beispiel</strong> zeigt die Grafik unten. Bei der ersten
Messung überlappt der Fehlerbalken mit dem wahren Wert, im “Slang” der
Physik würden wir sagen: “Die Messung stimmt innerhalb von einem <span
class="math inline">\(\sigma\)</span> (d.h. einer Standardabweichung)
mit dem wahren Wert überein”. Die zweite Messung ist nicht mit dem
wahren Wert verträglich: sie liegt zwar näher am wahren Wert, besitzt
aber eine viel kleinere Unsicherheit als die erste Messung, wir sagen:
“sie weicht um 5 <span class="math inline">\(\sigma\)</span> ab”.<br />
<img src="cMessung.png"
alt="Beispiel: Zwei verschiedene Messungen der Lichtgeschwindigkeit" /></p>
</blockquote>
<h2 id="wichtige-grundlagen-der-statistik">3 Wichtige Grundlagen der
Statistik</h2>
<p><a name="Chapter03"></a></p>
<p>Auf Grund des <strong>zentralen Grenzwertsatzes der
Wahrscheinlichkeitstheorie</strong> folgen die aus vielen
Einzelbeiträgen bestehenden zufälligen Abweichungen <span
class="math inline">\(u\)</span> der Messwerte vom wahren Wert einer
Gaußverteilung mit Mittelwert Null und Standardabweichung <span
class="math inline">\(\sigma\)</span>,</p>
<blockquote>
<p><span class="math inline">\(f_u(u) = \frac{1} {\sqrt{2\pi} \sigma}
\exp \left( -\frac {u^2} {2\sigma^2} \right)\,\)</span>.</p>
</blockquote>
<p>Ein Messwert <span class="math inline">\(m\)</span> ergibt sich aus
einem angenommenen wahren Wert <span class="math inline">\(m^w\)</span>,
zu dem die zufällige Abweichung <span class="math inline">\(u\)</span>
addiert wird:</p>
<blockquote>
<p><span class="math inline">\(m = m^w + u \,\)</span>.</p>
</blockquote>
<p>Damit ergibt sich die Verteilungsdichte der Messwerte zu</p>
<blockquote>
<p><span class="math inline">\(f_m(m) = \frac{1} {\sqrt{2\pi} \sigma}
\exp \left( -\frac{(m - m^w)^2} {2 \sigma^2} \right)\,\)</span>.</p>
</blockquote>
<h3 id="schätzung-der-unsicherheit-durch-wiederholte-messung">3.1
Schätzung der Unsicherheit durch wiederholte Messung</h3>
<p>Durch <span class="math inline">\(N\)</span>-mal wiederholte Messung
kann die Unsicherheit, definiert als die auf Verzerrung korrigierte
<strong>empirische Standardabweichung</strong> (auch:
Stichprobenstandardabweichung) der Messwerte, bestimmt werden:</p>
<blockquote>
<p><span class="math inline">\(\sigma^2 =
\frac{1}{N-1}\displaystyle\sum_{i=1}^N (m_i - \bar m)^2\)</span>,
wobei<br />
<span class="math inline">\(\bar{m} =
\frac{1}{N}\displaystyle\sum_{i=1}^N m_i\,\)</span> der Mittelwert der
Messungen ist.</p>
</blockquote>
<p>Falls Sie diese Gleichung selbst in Programmcode implementieren
möchten: durch folgende Umformung erhalten wir die numerisch effizienter
zu berechnende Darstellung</p>
<blockquote>
<p><span class="math inline">\(\sigma^2 =
\frac{1}{N-1}\displaystyle\sum_{i=1}^N {m_i}^2 -
\frac{N}{N-1}{\bar{x}}^2 \, \underset {N\to\infty} { \, \, \simeq \, \,
} \frac{1}{N}\displaystyle\sum_{i=1}^N {m_i}^2 -
{\bar{x}}^2\,\)</span>.</p>
</blockquote>
<p> </p>
<p>Wenn mehrere Größen gleichzeitig gemessen werden, stellt sich die
Frage, ob sie unabhängig voneinander sind, oder ob es einen Zusammenhang
zwischen den statistischen Effekten gibt, beide Größen also z.B.
bevorzugt in die gleiche Richtung abweichen. Als Maß dafür eignet sich
die <strong>Kovarianz</strong> zweier Größen <span
class="math inline">\(x\)</span> und <span
class="math inline">\(y\)</span>,</p>
<blockquote>
<p><span class="math inline">\({\rm cov}(m_x, m_y) =
\frac{1}{N}\displaystyle\sum_{i=1}^N ({m_x}_i - \bar{m}_x)\,({m_y}_i -
\bar{m}_y)\,\)</span>.</p>
</blockquote>
<p>Die Kovarianz der Größen <span class="math inline">\(m_x\)</span> und
<span class="math inline">\(m_y\)</span> ist Null, wenn sie unabhängig
sind. Wenn sie vollständig korreliert sind, nimmt sie den Wert <span
class="math inline">\(\sigma_{m_x} \sigma_{m_y}\)</span> an. Deshalb
wird der <strong>Korrelationskoeffizient</strong> wie folgt
definiert:</p>
<blockquote>
<p><span class="math inline">\(\rho=\displaystyle\frac {{\rm cov}(m_x,
m_y)} {\sigma_{m_x} \sigma_{m_y}}\, {\rm mit}\, -1 \le \rho \le
1\,\)</span>.</p>
</blockquote>
<p>Zwei Größen mit <span class="math inline">\(\rho&gt;0\)</span> werden
als <strong>korreliert</strong>, Größen mir <span
class="math inline">\(\rho&lt;0\)</span> als
<strong>antikorreliert</strong> bezeichnet.</p>
<p>Wenn es mehr als zwei Messgrößen <span
class="math inline">\(m_i\)</span> gibt, fassen wir die Kovarianzen von
Paaren von Messgrößen zur Kovarianzmatrix <span
class="math inline">\(\mathbf V\)</span> zusammen, deren Elemente
gegeben sind durch:</p>
<blockquote>
<p><span class="math inline">\(\left ({\mathbf V}\right)_{ij} = V_{i,j}
= {\rm cov}(m_i, m_j)\)</span>.</p>
</blockquote>
<p>Die Diagonalelemente <span class="math inline">\(V_{i,i}\)</span>
entsprechen den quadrierten Standardabweichungen der Messgrößen, <span
class="math inline">\(V_{i,i} = {\rm cov}(m_i, m_i) =
{\sigma_{m_i}}^2\)</span>. Für unkorrelierte Messgrößen mit
verschwindenden Kovarianzen ist <span class="math inline">\(\mathbf
V\)</span> eine Diagonalmatrix. Die Elemente der Kovarianzmatrix lassen
sich durch Mehrfachmessungen von Paaren <span
class="math inline">\((m_i, m_j)_k\)</span> durch Anwenden der
Definitionsgleichung für die Kovarianz auch empirisch aus den Daten
bestimmen.</p>
<p>Das Resultat einer gleichzeitigen Messung von zwei oder mehr
Messgrößen sollte also immer als <strong>Messwerte, Einheiten und
Kovarianzmatrix</strong> angegeben werden.</p>
<h3 id="fortpflanzung-der-unsicherheiten">3.2 Fortpflanzung der
Unsicherheiten</h3>
<p>Werden mehrere Messgrößen <span class="math inline">\(m_i,\,{\small
i=1, \ldots, n}\)</span> bestimmt, von denen eine gesuchte Ergebnisgröße
<span class="math inline">\(g(m_i)\)</span> abhängt, so wird die
Standardabweichung <span class="math inline">\(\sigma_g\)</span> von
<span class="math inline">\(g(m_i)\)</span> näherungsweise durch die
<strong>Fehlerfortpflanzungsformel</strong> bestimmt:</p>
<blockquote>
<p><span class="math inline">\({\sigma_g}^2 = \displaystyle \sum_1^n
\left(\frac{\partial g}{\partial m_i} \right)^2 \,
{\sigma_i}^2\,\)</span>.</p>
</blockquote>
<p><em>Anmerkung 1</em>: Zur Herleitung wird eine Taylorentwicklung von
<span class="math inline">\(g(m_i)\)</span> um die Messwerte <span
class="math inline">\(m_i\)</span> durchgeführt; die Formel ist also nur
anwendbar, wenn die Funktion im Bereich der Unsicherheiten <span
class="math inline">\(\sigma_i\)</span> gut durch eine Gerade
beschrieben wird.</p>
<p><em>Anmerkung 2</em>: Diese Gleichung gilt nur für unabhängige, d.h.
unkorrelierte Messungen. Wenn die Messungen korreliert sind, muss deren
Kovarianzmatrix berücksichtigt werden. Für den Spezialfall von zwei
Messungen lautet der Ausdruck für <span
class="math inline">\(\sigma_g\)</span>:</p>
<blockquote>
<p><span class="math inline">\({\sigma_g}^2 = \left(\frac{\partial
g}{\partial m_1} \right)^2 \, {\sigma_1}^2 + \left(\frac{\partial
g}{\partial m_2} \right)^2 \, {\sigma_2}^2 + 2 \frac{\partial
g}{\partial m_1} \frac{\partial g}{\partial m_2} {\rm cov}(m_1,
m_2)\,\)</span> mit der Kovarianz <span class="math inline">\({\rm
cov}(m_1, m_2)\)</span> von <span class="math inline">\(m_1\)</span> und
<span class="math inline">\(m_2\,\)</span>.</p>
</blockquote>
<h4 id="standardabweichung-des-mittelwerts">3.2.1 Standardabweichung des
Mittelwerts</h4>
<p>Wird die Fehlerfortpflanzungsformel auf den Mittelwert von <span
class="math inline">\(N\)</span> unabhängigen Messungen angewendet, so
ergibt sich für die Standardabweichung des Mittelwerts das wichtige
Ergebnis</p>
<blockquote>
<p><span class="math inline">\(\sigma_{\bar{m}} =
\frac{\sigma}{\sqrt{N}}\,\)</span>;</p>
</blockquote>
<p>d.h. <strong>die Unsicherheit auf die Messgröße reduziert sich durch
unabhängige, wiederholte Messungen</strong>. Die Reduktion der
Unsicherheit skaliert mit der Wurzel der Zahl der Messungen, z.B.
halbiert sich die Unsicherheit mit der vierfachen Zahl von
Messungen.</p>
<h3
id="zusammenhang-der-summe-der-residuenquadrate-mit-der-chi2-verteilung">3.3
Zusammenhang der Summe der Residuenquadrate mit der <span
class="math inline">\(\chi^2\)</span>-Verteilung</h3>
<p>Das Ziel einer Messung ist es, ein physikalisches Modell durch dem
Vergleich mit der Messreihe zu überprüfen (Hypothesentest). Wenn das
Modell geeignet ist, können die Modellparameter durch die Messwerte (im
statistischen Sinne) “geschätzt” werden. Im physikalischen Praktikum
kommt dazu häufig die <strong><span
class="math inline">\(\chi^2\)</span>-Methode</strong> zum Einsatz, die
auf einem Zusammenhang der in <a href="#Chapter01">Kapitel 1</a>
eingeführten Summe der Residuenquadrate <span
class="math inline">\(S\)</span> mit der <span
class="math inline">\(\chi^2\)</span>-Verteilung beruht. Werden die
Messwerte in die Gleichung für <span class="math inline">\(S\)</span>
eingesetzt, kann <span class="math inline">\(S\)</span> als Funktion der
Modellparameter aufgefasst werden und deren Werte am Minimum von <span
class="math inline">\(S\)</span>, hier als <span
class="math inline">\(S_0\)</span> bezeichnet, liefern Schätzwerte für
diese Parameter. Bei gaußförmigen Unsicherheiten der Messwerte
entspricht <span class="math inline">\(S_0\)</span> der Summe von
Quadraten von <span class="math inline">\(n\)</span> gaußverteilten
Zufallszahlen <span class="math inline">\(z_i\)</span>, <span
class="math inline">\(\chi^2=\sum_{i=1}^n {z_i}^2\)</span>, deren
Verteilungsdichte durch die <span
class="math inline">\(\chi^2\)</span>-Verteilung gegeben ist. Die <span
class="math inline">\(\chi^2\)</span>-Verteilung besitzt einen Parameter
<span class="math inline">\(N_f\)</span>, der als “Anzahl der
Freiheitsgrade” bezeichnet wird. Werden aus <span
class="math inline">\(N\)</span> Messwerten <span
class="math inline">\(n_p\)</span> Modellparameter bestimmt, so folgt
<span class="math inline">\(S_0\)</span> einer <span
class="math inline">\(\chi^2\)</span>-Verteilung mit <span
class="math inline">\(N_f= N - n_p\)</span> Freiheitsgraden, <span
class="math inline">\(\chi2(S_0, N_f)\)</span>.</p>
<p>Die <span class="math inline">\(\chi^2\)</span>-Verteilung ist in
allen gängigen Programmpaketen zur Statistik implementiert, so dass
leicht Werte der Dichteverteilung oder der kumulativen Verteilung und
damit Quantile der Verteilung berechnen werden können. Die <span
class="math inline">\(\chi^2\)</span>-Verteilung <span
class="math inline">\(\chi^2(x; N_f)\)</span> hat einen Erwartungswert
von <span class="math inline">\({\rm E} [\chi^2(N_f)] = N_f\)</span> und
eine Varianz <span class="math inline">\(\sigma^2 = {\rm
Var}[\chi^2(N_f)] = 2 N_f\)</span>.</p>
<p>Für den in einem Experiment beobachteten Wert <span
class="math inline">\(S_0\)</span> kann mit Hilfe der bekannten Quantile
der <span class="math inline">\(\chi^2\)</span>-Verteilung die
sogenannte <span
class="math inline">\(\chi^2\)</span>-Wahrscheinlichkeit <span
class="math inline">\(p_{\chi^2}\)</span> angeben werden. Dies ist die
Wahrscheinlichkeit dafür, bei einer Messreihe den beobachteten Wert für
<span class="math inline">\(S_0\)</span> oder einen größeren Wert zu
erhalten, unter der Annahme, dass das Modell zur Beschreibung der
Messung geeignet ist. Wenn diese Wahrscheinlichkeit zu klein ist, müssen
Annahmen über die Genauigkeit der Eingangsmessgrößen oder über die
Angemessenheit des Messverfahrens überdacht werden, oder die
Modellhypothese sollte angepasst bzw. verbessert werden, bevor ernsthaft
daran gedacht werden kann, gültige Werte für die Modellparameter zu
extrahieren. In der Praxis geschieht das häufig bei einem Wert von <span
class="math inline">\(p_{\chi^2} &lt; 0.05\)</span>.</p>
<blockquote>
<p><strong>Beispiel</strong>: Anstatt eines ohmschen Widerstands haben
Sie versehentlich eine Diode vermessen. Die Überprüfung des <span
class="math inline">\(\chi^2\)</span>-Wertes, also Schritt 4 aus Kap. 1,
bewahrt Sie davor, einer Halbleiterdiode einen ohmschen Widerstand
zuzuweisen!</p>
</blockquote>
<h3
id="parameteranpassung-und-bestimmung-der-parameterunsicherheiten">3.4
Parameteranpassung und Bestimmung der Parameterunsicherheiten</h3>
<p>Zur Schätzung der Parameter <span class="math inline">\(a_k\)</span>
eines an den Stützstellen (= Messpunkten) <span
class="math inline">\(x_i\)</span> ausgewerteten Modells <span
class="math inline">\(f(x_i, a_k)\)</span> aus den Messwerten <span
class="math inline">\(y_i\)</span> wird meist die bereits oben
eingeführte Summe der Residuenquadrate <span
class="math inline">\(S\)</span> verwendet. In vielen Fällen stellt dies
die optimale Methode dar, die die kleinste Varianz der
Parameterunsicherheiten liefert. <span class="math inline">\(S\)</span>
entspricht für gaußförmige, von den Modellparametern nicht abhängige
Unsicherheiten bis auf einen Faktor Zwei dem negativen Logarithmus der
Likelihood-Funktion, die in der mathematische Schätztheorie verwendet
wird. Allgemein schreibt man <span class="math inline">\(S\)</span> mit
Hilfe der Inversen der oben eingeführten Kovarianz-Matrix der
Unsicherheiten der Datenpunkte,</p>
<blockquote>
<p><span class="math inline">\(S\left(y_1,\ldots,y_N; f_1, \ldots, f_N
\right) = \displaystyle \sum_{i,j=1}^N \left( {f_i - y_i} \right)^T
\left( {\mathbf V}^{-1} \right)_{ij} \left( {f_j - y_j} \right) \,
\\\)</span><br />
mit der Notation <span class="math inline">\(f_i = f(x_i;
a_1,\ldots,a_{n_p})\)</span>.</p>
</blockquote>
<p>In dieser Form wird <span class="math inline">\(S\)</span> auch
verwendet, wenn die Messdaten korrelierte Unsicherheiten aufweisen, wenn
<span class="math inline">\(\mathbf V\)</span> also keine Diagonalmatrix
ist.</p>
<p>Informationen über die Unsicherheiten der Parameter werden aus dem
Verlauf der Verteilung <span class="math inline">\(S(y_i, x_i;
a_j)\)</span> in der Nähe des Minimums gewonnen. Das ist die Stelle im
Parameterraum, an der die Parameter ihre optimalen Werte <span
class="math inline">\(\hat{a}_j\)</span> annehmen, wie sie sich aus der
Minimierung von <span class="math inline">\(S\)</span> bzgl. der
Parameterwerte ergeben. Dabei wird <span
class="math inline">\(S\)</span> als Funktion der Parameter <span
class="math inline">\(a_j\)</span> aufgefasst, <span
class="math inline">\(S=S(a_j)\)</span>. Ein scharfes Minimum, also
große Krümmung von <span class="math inline">\(S(\hat{a}_j)\)</span> am
Minimum oder ein schneller Anstieg in der Nähe des Minimums, entsprechen
sehr genau bestimmten Parameterwerten; ist das Minimum flacher, die
Krümmung am Minimum oder der Anstieg kleiner, ist die Unsicherheit
größer. Der typische Verlauf von <span class="math inline">\(S\)</span>
am Minimum ist in der Grafik unten gezeigt.</p>
<p>Aus diesen Betrachtungen wird ersichtlich, dass die Unsicherheiten
mit den Krümmungen, also den zweiten Ableitungen von <span
class="math inline">\(S_0\)</span> nach den Parametern, zusammenhängen.
Für <span class="math inline">\(S\)</span> ergibt sich:</p>
<blockquote>
<p><span class="math inline">\({\rm Var}[\hat{a}_j] =
\sigma_{\hat{a}_j}^2 = 2 \left( \left. \frac{\partial^2 S} {{\partial
a_j}^2} \right|_{a_j = \hat{a}_j} \right)^{-1} \,\)</span>.</p>
</blockquote>
<p>Diese Methode wird von fast allen Anpassungsprogrammen zur Bestimmung
der Parameterunsicherheiten verwendet. Die Kehrwerte der gemischten
zweiten Ableitungen bestimmen im Falle mehrerer anzupassender Parameter
die Elemente der Kovarianzmatrix. Manche Anpassungsprogramme erlauben
es, Konfidenzkonturen von Paaren von Parametern anzuzeigen, die
vorhandene Korrelationen zwischen den Parameter anschaulich
illustrieren.</p>
<p>Genauer als die Bestimmung der Unsicherheiten aus den zweiten
Ableitungen am Minimum <span class="math inline">\(S_0\)</span> ist es,
einen kompletten Scan der Umgebung des Minimums durchzuführen und die
Punkte im Parameterraum zu markieren, an denen <span
class="math inline">\(S\)</span> um den Wert Eins größer ist als am
Minimum. Mit dieser Methode können Konfidenzintervalle für die
Parameterwerte bestimmt werden, die auch Gültigkeit haben, wenn die
Verteilung der Parameterunsicherheiten nicht gaußförmig ist. Diese
Methode erlaubt die Bestimmung asymmetrischer Unsicherheiten, die
68,3%-Konfidenzintervallen für die Parameterwerte entsprechen. Einige
der weiter unten vorgeschlagenen Programmpakete verwenden diese bessere
Methode entweder als Standard oder optional.</p>
<figure>
<img src="Dchi2.png"
alt="Typischer Verlauf von S am Minimum für ein physikalisches Modell mit einem Parameter. Eingezeichnet sind die Parameterunsicherheiten, die sich aus den zweiten Ableitungen (Fehlerbalken) oder aus dem Anstieg um Eins (graues Band) ergeben." />
<figcaption aria-hidden="true">Typischer Verlauf von <span
class="math inline">\(S\)</span> am Minimum für ein physikalisches
Modell mit einem Parameter. Eingezeichnet sind die
Parameterunsicherheiten, die sich aus den zweiten Ableitungen
(Fehlerbalken) oder aus dem Anstieg um Eins (graues Band)
ergeben.</figcaption>
</figure>
<h4
id="besonderheiten-bei-der-bestimmung-der-parameterunsicherheiten">3.4.1
Besonderheiten bei der Bestimmung der Parameterunsicherheiten</h4>
<p>In vielen Fällen werden Anpassungen genutzt, um Parameter zu
bestimmen, ohne einen Hypothesentest durchführen zu wollen. Die
Gültigkeit des verwendeten Modells wird dann als gegeben vorausgesetzt,
d.h.<br />
<span class="math inline">\(\chi^2/N_f \,\overset{!}{=}\,1\)</span> wird
postuliert. Diese Bedingung lässt sich erfüllen, wenn alle nach den oben
beschriebenen Verfahren bestimmten Parameterunsicherheiten mit einem
Faktor <span class="math inline">\(\sqrt{\chi^2/N_f}\)</span> skaliert
werden. Diese Skalierung der Parameterunsicherheiten mit der Wurzel aus
dem reduzierten Chi-Quadrat <span
class="math inline">\(\chi^2/N_f\)</span> ist die Standardeinstellung in
den meisten Anpassungsprogrammen. In der Physik ist diese Vorgehensweise
sinnvoll, wenn lediglich eine Parametrisierung benötigt wird, die
gegebene Daten im Rahmen der Messunsicherheiten möglichst gut
repräsentiert. Wenn Sie allerdings eine Überprüfung der Modellhypothese
benötigen, müssen Sie unbedingt daran denken diese voreingestellte
Option abzuschalten!</p>
<h3 id="parameter-mit-externen-einschränkungen">3.5 Parameter mit
externen Einschränkungen</h3>
<p>In manchen Fällen kommen in einer Modellfunktion Parameter vor, über
die Kenntnisse aus externen Messungen oder aus Hilfsmessungen vorliegen,
wie z.B. Naturkonstanten oder die Eigenschaften von Messgeräten
(Federkonstante eines Federkraftmessers, Kalibrationsfaktoren usw.). Wir
nehmen an, dass für diese Parameter <span
class="math inline">\(p_k\)</span> bereits ein Schätzwert <span
class="math inline">\(p_k^0\)</span> und eine Unsicherheit <span
class="math inline">\(\sigma_{p_k}\)</span> bekannt sind. In der
Parameteranpassung werden daher Abweichungen der Parameter von <span
class="math inline">\(p_k^0\)</span> zugelassen, indem sie mit einem
zusätzlichen Summanden in der Summe der Residuenquadrate berücksichtigt
werden:</p>
<blockquote>
<p><span class="math inline">\(\tilde{S} = S + \displaystyle
\sum_{k=1}^{n_p} { \left( \frac {p_k - p_k^0} {\sigma_{p_k}}
\right)}^2\)</span>.</p>
</blockquote>
<p>Je weiter <span class="math inline">\(p_k\)</span> von <span
class="math inline">\(p_k^0\)</span> abweicht, desto größer wird der
Wert von <span class="math inline">\(\tilde{S}\)</span>. Der Vorteil
dieser Methode besteht darin, dass die Unsicherheiten der extern
festgelegten Parameter bei der Bestimmung der Unsicherheiten der
interessierenden Parameter mit berücksichtigt werden. Eine händische
Fortpflanzung dieser Unsicherheiten in das Endergebnis ist bei
Verwendung dieser Methode also nicht notwendig.</p>
<h1 id="anhang">Anhang</h1>
<p><a name="Appendix"></a></p>
<h2 id="a1-übersicht-hilfsmittel-für-die-physikalischen-praktika">A1
Übersicht: Hilfsmittel für die physikalischen Praktika</h2>
<p><a name="AppendixA1"></a></p>
<p>Als Vorbereitung zum Einsatz rechnergestützter Methoden in den
Praktika wird an der Fakultät für Physik am KIT die Vorlesung
“Computergestützte Datenauswertung” mit praktischen Übungen angeboten <a
href="https://comp.physik.kit.edu/Lehre/CGDA/">[<strong>Link
CgDA</strong>]</a>.</p>
<p>Eine Programmbibliothek mit nützlichen Funktionen und Beispielen zur
Unterstützung typischer Aufgaben bei der Auslese, Visualisierung und
Auswertung von Daten in den physikalischen Praktika liefert das Paket <a
href="http://etpwww.etp.kit.edu/~quast/PhyPraKit/htmldoc/">[<strong>PhyPraKit</strong>]</a>.
Die in diesem Paket enthaltenen Beispiele können als Vorlagen für eigene
<em>Python</em>- Skripe zur Versuchsauswertung dienen, und daher
empfiehlt es sich, das gesamte <a
href="https://git.scc.kit.edu/yh5078/PhyPraKit/-/archive/master/PhyPraKit-master.zip">Paket
als gepackte Datei im <em>.zip</em>-Format</a> herunter zu laden.</p>
<p>Zur Einführung in die Grundlagen der statistischen Datenauswertung,
die Anwendung der Skript-Sprache <em>Python</em> und fortgeschrittene
Methoden stehen Tutorials zu den Themen “Grundlagen der Statistik” und
“Fehlerrechnung” als Jupyter-Notebooks zur Verfügung, s. <a
href="http://ekpwww.etp.kit.edu/~quast/jupyter/jupyterTutorial.html">[<strong>Link
Jupyter-Tutorials</strong>]</a>.</p>
<p>Das Skript <a
href="https://etpwww.etp.kit.edu/~quast/Skripte/Chi2Method.pdf">[<strong>Funktionsanpassung
mit der <span
class="math inline">\(\chi^2\)</span>-Methode</strong>]</a> erklärt die
Grundlagen der Anpassung von Funktionen an Messdaten und beschreibt
einige der gängigen Werkzeuge.</p>
<p>Für die Arbeit von PhysikerInnen ist die Entwicklung von Methoden zur
Lösung neuer Problemstellungen wichtig, die in der Regel die Erstellung
von eigenem Programmcode notwendig machen, weil Standard-Lösungen noch
nicht existieren. Dennoch gibt es viele immer wiederkehrende
Routineaufgaben, die durchaus mit Standard-Programmen gelöst werden
sollten.</p>
<ol type="a">
<li><p>Einige der üblichen Programmpakete setzen einfache
Programmierkenntnisse in der Sprache <em>Python</em> voraus. Damit wird
direkt und sehr flexibel das Programmierinterface (API = “Application
Programming Interface”) angesprochen. Dieser Zugang empfiehlt sich für
den besonders programmier-affinen Teilnehmerkreis.</p></li>
<li><p>Für die Durchführung von Datenauswertungen in den physikalischen
Praktika am KIT empfiehlt sich allerdings das Paket <em>PhyPraKit</em>
(siehe <a
href="http://git.scc.kit.edu/yh5078/PhyPraKit">[<code>PhyPraKit Download Link</code>]</a>,
das vereinfachte Schnittstellen, sogenannte (“Wrapper-Funtionen”) bereit
stellt, um den notwendigen eigenen Programmcode zu minimieren. Die
Anwendung dieser Funktionen ist in zahlreichen Beispielen im Verzeichnis
<code>PhyPraKit/examples</code> illustriert.</p></li>
<li><p>Weiter enthält <em>PhyPraKit</em> auch einige eigenständige
Programme, die die Visualisierung von Daten und Modellen und die
Anpassung von Modellen an Messdaten ermöglichen, ohne eigenen
<em>Python</em>-Code zu erstellen:</p></li>
</ol>
<ul>
<li>Mit dem Script <em>plotData.py</em> lassen sich eine oder mehrere
Messreihen von Wertepaaren grafisch darstellen. Möglich ist auch die
Darstellung von Messreihen als Häufigkeitsverteilungen
(“Histogramme”).</li>
<li>Mit dem Script <em>plotCSV.py</em> können Daten in Dateien im
<em>csv</em>-Format direkt angezeigt werden. Das zur Trennung der Felder
verwendet Separator-Zeichen (voreingestellt ist ‘,’) oder die Zahl der
Kopfzeilen (Vorgabe ist 1) können als Option angegeben werden.</li>
<li>Das Script <em>run_phyFit.py</em> dient dazu, Anpassungen von
Modellen an Messreihen von Wertepaaren durchzuführen; die Daten und das
Modell werden dabei aus einer in der einfachen Datenbeschreibungssprache
<em>yaml</em> erstellen Text-Datei gelesen.</li>
<li>Das Scritpt <em>csv2yaml.py</em> erlaubt die Konversion von
Eingabedaten im häufig verwendeten <em>csv</em>-Format in einen gültigen
Ausdruck in der Datenbeschreibungssprache <em>yaml</em>, die von den
Programmen oben zur Dateneingabe verwendet wird. Auch das
Windows-Programm Excel oder machen in den Praktika verwendeten Programme
zur Auslese von Geräten von Lehrmittelfirmen unterstützen das
<em>csv</em>-Format. Bei Verwendung einer deutschen
Betriebssystemversion werden Daten allerdings als deutsche Dezimalzahl.
also mit ‘,’ anstelle von ‘.’, abgespeichert, und deshalb erledigt diese
Script auch die ggf. notwendige Umwandlung, um mit wissenschaftlichen
Pakten zur Datenauswertung kompatibel zu sein.<br />
</li>
<li>Das Script <em>kafe2go</em> aus dem Paket <em>kafe2</em> dient (wie
auch <em>run_phyFit</em>) zur Anpassung von Modellen an Daten, bei denen
die gesamte Anpassung basierend auf einer <em>yaml</em>Datei
durchgeführt wird. <em>kafe2go</em> ist sehr viel funktionsreicher als
<em>run_phyFit.py</em>, das Datenformat ist aber kompatibel.</li>
</ul>
<p>Es gibt viele weitere Werkzeuge, mit denen sich typische Aufgaben der
Darstellung und Auswertung von Daten bewerkstelligen lassen. Nicht alle
davon können flexibel genug mit den typischen Unsicherheiten bei
physikalischen Messungen umgehen, oder die Standardeinstellungen
erlauben es nicht, die Gültigkeit der angenommenen Modellhypothese zu
überprüfen. Auch die strikte Interpretation der ausgegebenen
Parameterunsicherheiten als Konfidenzbereich ist nicht in jedem Fall
gegeben. Es ist also erforderlich, die jeweiligen Optionen anzupassen,
um nachvollziehbare und zu den üblichen Anforderungen in der Physik
konforme Ergebnisse zu erhalten.</p>
<h2 id="a2-empfehlungen-zur-praktischen-vorgehensweise">A2 Empfehlungen
zur praktischen Vorgehensweise</h2>
<p><a name="AppendixA2"></a></p>
<p>Zur Durchführung der mit Computerunterstütung vergesehenen Arbeiten
in den Praktika wird Ihnen im Normalfall eine über einen beliebigen
Web-Browser zugängliche Arbeitsumgebung bereit gestellt. Dazu werden
üblicherweise sogenannte Jupyter-Notebooks (s. weiter unten) genutzt,
die die Programmiersprache <em>Python</em> voraussetzen.</p>
<p>Es ist allerdings auch kein Problem, eine entsprechende Umgebung auf
Ihren eigenen Computer aufzusetzen. Ob Sie einen Jupyter-Server auf
Ihrem eigenen System oder auf einem Server des entsprechenden Kurses
nutzen, macht zwar kaum einen Unterschied; auf Ihrem eigenen System sind
Sie aber flexibler, arbeiten stets in der gleichen gewohnten Umgebung
und können von Ihnen erstellten Programmcode leichter auf andere
Projekte übertragen.</p>
<h3 id="a2.1-arbeitsumgebung-auf-dem-computer">A2.1 Arbeitsumgebung auf
dem Computer</h3>
<p>Es gibt für die verschiedenen Computer-Plattformen (Microsoft
Windows, Apple OS, Linux oder Chromebook) eine schier unüberschaubare
Anzahl von verschiedenen Applikationen zur Datenvisualisierung und
-analyse, die mit einer ebenso kaum überschaubaren Anzahl an Optionen
und mit bisweilen sehr komplexen Nutzeroberflächen eine Vielzahl von
Anwendungsfällen abzudecken versuchen.</p>
<p>In der wissenschaftlichen Datenanalyse haben sich frei zugängliche
und kostenlos verfügbare Lösungen etabliert. Insbesondere das neue
Gebiet “Data Science” setzt dabei auf die Sprache <em>Python</em>, die
als interpretierte Sprache einerseits einen schnellen Entwicklungszyklus
von Code zur spezialisierten Datenanalyse bietet, andererseits aber auch
mächtige, hochperformante Bibliotheken zur numerischen Datenverarbeitung
mitbringt.</p>
<p>Da es die Programmiersprache <em>Python</em> auf allen verbreiteten
Plattformen und sogar auf Einplatinencomputern gibt, ist es sinnvoll,
auch für die Datenauswertung in den Praktika zur Physik auf Lösungen in
<em>Python</em> zu setzen. Auf Windows- und neueren Apple-Systemen ist
<em>Python</em> leider nicht standardmäßig vorhanden und muss erst noch
installiert werden. Dazu werden in den AppStores entsprechende Pakete
angeboten. Wenn <em>Python</em> installiert und die Hilfsprogramme im
Pfad der ausführbaren Programme aufgeführt sind, ist die Vorgehensweise
aber immer gleich.</p>
<p>In <em>Python</em> geschriebene Programme werden üblicherweise über
die Kommandozeile gestartet; auch die Installation und Konfiguration von
Programmpaketen erfolgt über die Kommandozeile. Nach der Installation
von <em>Python</em> sollten Sie zunächst einige der wichtigsten
Programme und Pakete installieren. Dies erledigen Sie über den Package
Installer <code>pip</code> (bzw. <code>pip3</code> bei Systemen, auf
denen auch noch die ältere Version 2.7 von Python installiert ist).</p>
<p>Geben Sie zur Installation der zusätzlich benötigten Pakete
nacheinander folgende Befehle ein:</p>
<pre><code>&gt; pip3 install kafe2
&gt; pip3 install PhyPraKit</code></pre>
<ul>
<li><code>kafe2</code> ist ein flexibles Paket zur Anpassung von
Modellen an Messdaten.</li>
<li><code>PhyPraKit</code> ist das oben schon erwähnte Paket mit
Beispielen für konkrete Anwendungen in den Praktika.</li>
</ul>
<p>Bei Installation von <em>kafe2</em> werden automatisch wichtige
Pakete mitinstalliert.</p>
<ul>
<li><code>numpy</code> ist eine mächtige Bibliothek zur Durchführung
effizienter Berechnungen von mathematischen Funktionen auf großen
Datenmengen.</li>
<li><code>matplotlib</code> ist eine Bibliothek zur Erstellung
ansprechender Grafiken zur Visualisierung von Daten.</li>
<li><code>iminuit</code> ist ein Paket zur numerischen Minimierung einer
Kostenfunktion und zur Analyse der Unsicherheiten, das von den
Anpassungen in <code>kafe2</code> und <code>PhyPraKit</code> verwendet
wird.</li>
</ul>
<p> </p>
<p><strong>Jupyter Notebooks</strong></p>
<p>Wenn Sie als Umgebung zur Ausführung von <em>Python</em>-Code Jupyter
Notebooks ausprobieren möchten, installieren sie noch:</p>
<pre><code>&gt; pip3 install jupyterlab</code></pre>
<p>Die Jupyter-Umgebung wird auf allen Systemen gestartet durch Eingabe
von</p>
<pre><code>&gt; jupyerlab</code></pre>
<p>beziehungsweise über <em>Python</em> mit dem Befehl</p>
<pre><code>&gt; python -m jupyerlab .</code></pre>
<p>Dies startet einen lokalen Web-Server, mit dem sich normalerweise ein
automatisch startender Web-Browser verbindet. Sie können nun Beispiele
mit der Dateiendung <em>ipynb</em> ausführen und modifizieren oder auch
eigenen Python-Code eingeben und ausführen. Die Browser-Oberfläche
fungiert dabei als komplette Entwicklungsumgebung, in der Code,
Dokumentation und Programmausgaben in Textform oder auch grafisch
ausgegeben werden.</p>
<p>Weitere nützliche Programme sind das Textsatz-Programm <em>LaTeX</em>
und das Paket <em>pandoc</em>, mit denen sich Dokumentation und auch
Praktikumsprotokolle erstellen lassen. Auf vielen Systemen ist die
<em>LaTeX</em>-Version <em>TexLife</em> installiert; für MS Windows
empfiehlt sich wegen der einfacheren Installation die Variante
<em>MiKTeX</em>, die neben einer ganzen Anzahl an nützlichen
Hilfsprogrammen und einem Kommandozeilen-Interface auch eine grafische
Oberfläche <em>texworks</em> zur Erzeugung und Darstellung von
Dokumenten mitbringt.</p>
<p>Das Paket <em>pandoc</em> ermöglicht es, Dokumente in der
leichtgewichtigen und von Menschen gut lesbaren “Markdown”-Sprache zur
verfassen; Ausdrücke in <em>LaTeX</em> werden dann nur für Formeln
benötigt.<br />
<em>Anmerkung:</em> Dieses Dokument wurde in <em>Markdown</em> erstellt
und mit Hilfe von <em>pandoc</em> ins <em>pdf</em>-Format
umgewandelt.</p>
<p> </p>
<p><strong>Beispiele und Programme aus PhyPraKit</strong></p>
<p>Sie sollten zusätzlich noch die Beispiele und Programme aus dem Paket
<em>PhyPraKit</em> herunter laden. Diese finden Sie unter dem Link: <a
href="https://git.scc.kit.edu/yh5078/PhyPraKit">[<code>PhyPraKit</code>]</a>.
Verwenden Sie das Download-Symbol und kopieren Sie alle Dateien im
<em>gitlab</em>-Repository als <em>zip</em>-Datei herunter. Entpacken
sie alles in ein Verzeichnis mit einem aussagekräftigen Namen, z.B.
<code>Praktikum/PhyPraKit</code>. Im Verzeichnis
<code>PhyPraKit/docs</code> finden Sie die Datei
<code>PhyPraKit.pdf</code> mit einer ausführlichen Dokumentation aller
enthaltenen Module und der Beispiele im Verzeichnis<br />
<code>PhyPraKit/examples</code> bzw. der Jupyter-Notebooks in
<code>PhyPraKit/ipynb_examples/</code>.</p>
<p><code>PhyPraKit</code> enthält die oben bereits erwähnten Programme,
die Standardaufgaben auch ohne die Erstellung von eigenem Programmcode
lösen. Für die meisten Aufgaben sind diese Standard-Programme
ausreichend; für den einzelnen Anwendungsfall angepasst werden müssen
nur die Daten und Metadaten in der Eingabedatei im
<em>yaml</em>-Format.</p>
<p>Für komplexere Aufgaben gibt es Beispiele in <em>Python</em>, die als
Vorlage zur Anpassung für ähnliche Aufgabenstellungen gedacht sind. Zur
direkten Anwendung der API der Programmpakete <em>kafe2</em> oder
<em>PhyPraKit.phyFit</em> studieren Sie am besten den Code der in den
Beispielen aufgerufenen Wrapper-Funktionen, oder Sie nutzen die
entsprechenden API-Dokumentationen.</p>
<h3 id="a2.1-digitale-datenformate">A2.1 Digitale Datenformate</h3>
<p>Bei Verwendung von vorgegebenen Programmen müssen Daten in den von
diesen unterstützten Formaten vorliegen. Ein sehr einfaches, weit
verbreitetes Format ist dabei das <code>csv</code>-Format
(<strong>c</strong>omma bzw. <strong>c</strong>haracter
<strong>s</strong>eparated <strong>v</strong>alues), bei dem die Daten
in Zeilen vorliegen und die einzelnen Datenwerte in einer Zeile durch
Kommata oder häufig auch andere Zeichen (Tabulator, Leerzeichen, ;)
getrennt werden. Damit lässt sich z.B. eine Tabelle gut abbilden:</p>
<table>
<thead>
<tr class="header">
<th>a</th>
<th>b</th>
<th>c</th>
</tr>
</thead>
<tbody>
<tr class="odd">
<td>1</td>
<td>2</td>
<td>3</td>
</tr>
<tr class="even">
<td>4</td>
<td>5</td>
<td>6</td>
</tr>
</tbody>
</table>
<p>die als <code>csv</code>-Datei dargestellt so aussieht:</p>
<pre><code>a,b,c
1,2,3
4,5,6</code></pre>
<p>Es ist möglich, Daten in diesem Format in eine Excel-Tabelle
einzulesen oder auch Excel-Daten in diesem Format zu exportieren.</p>
<p>Leider bietet dieses einfache Format keine Möglichkeit, komplexere
Datenstrukturen oder die ebenfalls benötigten Metadaten darzustellen.
Für die Programmpakete in <em>PhyPraKit</em> und <em>kafe2</em> wurde
deshalb als Datenformat die einfache Datenbeschreibungssprache
<code>yaml</code> gewählt. Unsere Tabelle sieht in diesem Format so
aus:</p>
<pre><code>a: [1,4]
b: [2,5]
c: [3,6]</code></pre>
<p>Der Vorteil ist, dass weitere Schlüssel hinzugefügt werden können, um
zusätzliche Information anzugeben. Auch vom einlesenden Programm nicht
ausgewertete, durch das Zeichen <code>#</code> eingeleitete
Kommentarzeilen sind möglich:</p>
<pre><code># Beispiel einer Datei im yaml-Format
Datentyp: &quot;Einfache Tabelle&quot;
Datum:    11.11.2011 
a: [1,4]
b: [2,5]
c: [3,6]
</code></pre>
<p>Eingelesen in ein Programm entspricht die Datenstruktur der eines
sogenannten “Dictionaries”, d.h. eines “assoziativen Feldes”, bei dem
Datenstrukturen mit einem Text oder einer Zahl als Schlüssel indiziert
werden. Die vom <em>yaml</em>-Format unterstützten Kommentarzeilen
werden zwar beim Einlesen ignoriert, sind aber zur Strukturierung der
Daten und zur Dokumentation von Optionen für den Ersteller oder Leser
der Datei extrem hilfreich.</p>
<p>In unserem Beispiel sind die Datenstrukturen Listen aus Zahlen, Text
oder ein Datum. Es wäre auch möglich, eine ganze Tabelle mit ihren
Metadaten als eigene Datenstruktur einzubinden, oder auch viele Tabellen
mit ganz unterschiedlicher Bedeutung in einem Dokument zu vereinen.</p>
<p>Ein weiteres Beispiel für Messdaten mit Unsicherheiten und einer als
Python-Code dargestellten Funktion veranschaulicht die Relevanz für
typische Problemstellungen im Praktikum:</p>
<pre><code># data.ydat: Beispiel-Datei im yaml-Fromat
# ---------------------------------------------------------------
title: &quot;Beispiel aus Datei &#39;data.yaml&#39;&quot;
x_label: &#39;x-Werte&#39;
y_label: &#39;y-Werte&#39;

label: Zufallsdaten
x_data: [0., 0.2, 0.4, 0.6, 0.8, 1., 1.2, 1.4, 1.6, 1.8, 2., 2.2, 2.4, 2.6]
x_errors: [0.01,0.015,0.02,0.025,0.03,0.035,0.04,0.045,0.05,0.055,0.06,
            0.065,0.07,0.075]
y_data: [ 1.149, 0.712, 0.803, 0.464, 0.398, 0.355, 0.148,
          0.328, 0.181, 0.140, 0.0651, 0.005, -0.005, 0.116 ]
y_errors: 0.07

# optional model specification
model_label: &#39;Exponential&#39;
model_function: |
    def exp_model(x, A=1., x0=1.):
      return A*np.exp(-x/x0)</code></pre>
<p>Mit Hilfe des Programms <code>plotData.py</code> und dem Aufruf<br />
<code>&gt; python3 plotData.py data.ydat</code><br />
wird dann daraus die unten gezeigte grafische Ausgabe erzeugt.</p>
<p>Das Programm <code>plotData.py</code> ist auch bei der händischen
Datenerfassung sehr nützlich, weil damit ohne viel Aufwand eine
grafische Überprüfung der Daten schon während der Datenaufnahme möglich
ist.<br />
<img src="plotxyData.png"
alt="Mit plotData.py erzeugte Grafik von Wertepaaren" /></p>
<p>Die Programme <code>PhyPraKit/examples/run_phyfit.py</code> und
<code>kafe2go</code> aus dem Paket <code>kafe2</code> nutzen das gleiche
Eingabeformat zur Durchführung von Anpassungen der Modellparameter an
die Messdaten.</p>
<p><strong><em>Hinweis</em></strong>: Daten aus üblichen Programmen wie
<em>LibreOffice</em> oder <em>MS Office</em> oder auch von manchen
Geräten wie Datenloggern oder Oszilloskopen werden im
<em>csv</em>-Format ausgegeben. Zur Konversion in einen
<em>yaml</em>-Block gibt es in PhyPraKit das Script
<code>csv2yml.py</code>.</p>
<h3 id="a2.2-bestimmung-der-unsicherheiten-von-messdaten">A2.2
Bestimmung der Unsicherheiten von Messdaten</h3>
<p>Wie bereits eingangs erläutert, ist es für die Interpretation von
Messergebnissen in der Physik essentiell, die Messunsicherheiten zu
kennen.</p>
<p>Durch wiederholte Messung lassen sich zufällige (also statistische)
Einflüsse quantifizieren.</p>
<p>Abweichungen oder Unzulänglichkeiten des Messgeräts oder der
Messmethode, sogenannte systematische Unsicherheiten, lassen sich auf
diese Weise aber nicht bestimmen, sondern dazu muss auf Angaben des
Herstellers oder des Urhebers des Messverfahrens zurück gegriffen
werden.</p>
<p><strong>A2.2.1</strong> Wiederholte Messung zur Bestimmung
statistischer Unsicherheiten</p>
<p>Um die Unsicherheiten von Messungen abzuschätzen, kann man die
gleiche Größe mehrmals unabhängig messen, z.B. von mehreren Personen,
oder durch möglichst unabhängige Wiederholung der gesamten Messprozedur
inklusive der Neuausrichtung bzw. Neuverbindung des Messgeräts. Aus der
Standardabweichung der Messwerte ergibt sich dann der Wert für die
Unsicherheit einer Einzelmessung. Für diese Vorgehensweise gibt es ein
vom Programm <code>plotData.py</code> unterstütztes Datenformat zur
Erstellung von Häufigkeitsverteilungen und zur Berechnung der
statistischen Daten, wie im folgenden Beispiel gezeigt:</p>
<pre><code>  # hData.ydat: Beispiel einer Histogramm-Darstellung
  # -------------------------------------------------
  type: histogram
  title: &quot;Wiederholte Messungen von Tischhöhen&quot;
  
  label: Beispieldaten
  x_label: &#39;Höhe h (cm)&#39;
  y_label: &#39;Verteilungsdichte f(h)&#39;
  
  # Daten:
  raw_data: [
     79.83,79.63,79.68,79.82,80.81,79.97,79.68,80.32,79.69,79.18,
     80.04,79.80,79.98,80.15,79.77,80.30,80.18,80.25,79.88,80.02 ]
  
  n_bins: 20
 bin_range: [79., 81.]
   # alternatively an array for the bin edges can be specified
  #bin_edges: [79., 79.5, 80, 80.5, 81.]

  model_label: Gauss-Verteilung
  model_density_function: |
    def normal_distribution(x, mu=79.9, sigma=0.346):
      return np.exp(-0.5 *((x-mu)/sigma)**2)/np.sqrt(2.*np.pi*sigma**2)</code></pre>
<p>Die Ausgabe enthält auch die Angabe von Mittelwert und
Standardabweichung der eingegebenen Daten. Die eingezeichnete Funktion
repräsentiert die Verteilungsdichte, die zur Berücksichtigung der
Bin-Breite im Histogramm und der Anzahl der Einträge entsprechend
skaliert wurde. Die in der Eingabedatei anzugebende Verteilungsdichte
ist dagegen auf die Fläche von Eins normiert.<br />
<img src="plothistData.png"
alt="Mit plotData.py erzeugte Histogrammdarstellung" /></p>
<p><strong>A2.2.2</strong> Apparative Unsicherheiten</p>
<p>Alle Messgeräte haben eine endliche Genauigkeit, die typischerweise
im jeweiligen Datenblatt angegeben ist. Solche auf das Messgerät oder
die Messmethode zurück zu führende “systematische Unsicherheiten”
betreffen alle aufgenommenen Messwerte in gleicher Weise und lassen sich
durch Mehrfachmessungen auch nicht verringern.</p>
<p>Wenn mehrere Messgeräte des gleichen Typs vorhanden sind, kann man
allerdings die Methode aus 5.2.1 anwenden und die Unsicherheiten aus der
Streuung der mit verschiedenen Geräten der gleichen Serie erhaltenen
Messergebnisse bestimmen. Die systematische Unsicherheit ist damit auf
eine statistische Unsicherheit zurückgeführt.</p>
<blockquote>
<p><strong>Beispiel:</strong> Die Genauigkeit von digitalen Messgeräten
wird typischerweise in der Form “<span
class="math inline">\(\pm\)</span> x% + y digits” angegeben. Die erste
Unsicherheit ist dabei die Kalibrationsunsicherheit des Geräts; dies ist
eine relative, auf den wahren Wert bezogene Unsicherheit, die alle
Messungen in gleicher Weise betrifft, etwa so wie ein zu langer oder zu
kurzer Maßstab bei Längenmessungen. Die zweite Größe ist die
statistische Unsicherheit jeder Einzelmessung, angegeben in Abweichungen
der letzten Ziffer der Anzeige. In der Praxis kommen dazu noch
statistische Unsicherheiten durch Rauschen, das über die Messleitungen
und den Aufbau eingestreut wird, oder Übergangswiderstände an der
Kontaktstelle.</p>
</blockquote>
<p>Da sich Unsicherheiten quadratisch addieren, d.h.<br />
<span class="math inline">\({\sigma_{\rm tot}}^2 = \sqrt{\sum_i
\sigma_i^2}\)</span> gilt, können häufig die kleinsten Unsicherheiten
vernachlässigt werden. In der Praxis dominiert oft das als statistisch
anzusehende Rauschen. Wenn aber die relative, auf den wahren Wert
bezogene Unsicherheit dominiert, müssen Verfahren angewandt werden, die
korrelierte, relative Unsicherheiten korrekt berücksichtigen können.</p>
<p>Die Berücksichtigung von allen oder mehreren Messwerten gemeinsamen
Unsicherheiten benötigt entweder die Einführung der Kovarianzmatrix
aller Messunsicherheiten, wie es in den Paketen <em>kafe2</em> und
<em>PhyPraKit/phyFit</em> vorgesehen ist. Man kann das Problem in
einfache Fällen aber auch durch Iteration lösen, indem man mehrere
Datenauswertungen mit jeweils um die gemeinsamen Unsicherheiten
verschobenen Messwerten durchführt und die sich ergebenden Abweichungen
der erhaltenen Ergebnisse als jeweilige Unsicherheit verwendet. Am Ende
ergibt sich die Gesamtunsicherheit als die Wurzel der Summe aller so
ermittelten, quadrierten Unsicherheiten.</p>
<h3 id="a2.3-einfache-durchführung-von-modellanpassungen">A2.3 Einfache
Durchführung von Modellanpassungen</h3>
<p>Die Grundlagen der Anpassung von Modellen an Messdaten sind in der
Literatur und in den oben bereits erwähnten Skripten und
Jupyter-Tutorials ausführlich beschrieben.</p>
<p>Vor allem die vielfältigen Methoden zur analytischen Behandlungen von
linearen, quadratischen oder nicht-linearen Regression lassen das Thema
unnötig komplex erscheinen. Im wesentlichen geht es lediglich darum, ein
geeignetes Abstandsmaß zwischen einer Modellfunktion <span
class="math inline">\(f()\)</span> und einer Anzahl von <span
class="math inline">\(N\)</span> mit Unsicherheiten behafteten Messdaten
<span class="math inline">\(y_i\)</span> bezüglich der Parameter <span
class="math inline">\(a_k\)</span> zu minimieren:</p>
<blockquote>
<p><span class="math inline">\(\min_{a_j}{ D( f(x_i; \, a_1, ..,
a_{n_p}),\, y_i})\)</span>.</p>
</blockquote>
<p>Eine ganz einfache Lösungsmethode besteht schon darin, den Abstand
<span class="math inline">\(D\)</span> als Funktion der Parameter
grafisch darzustellen und dann das Minimum zu suchen. Dazu ist kein
ausgefeilter Algorithmus notwendig, sondern es reichen einige Zeilen
<em>Python</em> Code.</p>
<p>Als Beispiel zeigt die rechte Seite der Grafik unten 10 Messwerte
<span class="math inline">\(m_1, ..., m_{10}\)</span> und einige
konstante Funktionen. Welche davon passt am besten zu den Daten?</p>
<p>Um eine quantitative Antwort zu finden, wählen wir die Summer der
Residuenquadrate als Abstandsmaß <span
class="math inline">\(D(C)=S(C)\)</span>; aufgefasst als Funktion des
Parameters C ergibt sich die Gleichung einer Parabel:</p>
<blockquote>
<p><span class="math inline">\(D(C) = \displaystyle \sum_{i=1}^{10}
\frac{(y_i - C)^2 }{{\sigma}^2} \,\)</span>.</p>
</blockquote>
<p>Das Abstandsmaß als Funktion von <span
class="math inline">\(C\)</span> ist im linken Teil der Grafik
dargestellt. Die Parabelform und auch die Position des Minimums <span
class="math inline">\(\hat{C}\)</span> sind klar sichtbar. Der Wert von
<span class="math inline">\(\chi^2=D(\hat{C})\)</span> und die sich
daraus ergebende <span
class="math inline">\(\chi^2\)</span>-Wahrscheinlichkeit sind ebenfalls
angegeben.</p>
<figure>
<img src="GraphicalFit.png"
alt="In der rechten Grafik sind 10 Messwerte und 5 mögliche konstante Funktionen gezeigt. Der Wert des Abstandsmaßes für verschiedene Werte der Konstanten ist links dargestellt." />
<figcaption aria-hidden="true">In der rechten Grafik sind 10 Messwerte
und 5 mögliche konstante Funktionen gezeigt. Der Wert des Abstandsmaßes
für verschiedene Werte der Konstanten ist links
dargestellt.</figcaption>
</figure>
<p>Übrigens entspricht der so bestimmte Wert von <span
class="math inline">\(\hat{C}\)</span> dem Mittelwert der Messwerte.
Dies kann man leicht durch analytische Bestimmung des Minimums von <span
class="math inline">\(D(C)\)</span> verifizieren.</p>
<p>Auch bei komplizierterem Verlauf der Funktion <span
class="math inline">\(f(x_i; a_k)\)</span> bleibt die numerische
Herangehensweise die gleiche - im Ausdruck für D wird lediglich <span
class="math inline">\(C\)</span> durch <span
class="math inline">\(f(x_i; a_k)\)</span> ersetzt. Wir können das
Anpassungsproblem also durch Verwendung eines einfachen
Funktionen-Plotters lösen, indem man <span
class="math inline">\(D(a_k)\)</span> grafisch darstellt.</p>
<p>Das skizzierte Verfahren funktioniert noch gut mit zwei Parametern,
bei drei und mehr wird es numerisch sehr ineffizient; dann setzt man
spezielle Algorithmen der numerischen Optimierung ein, um das Optimum
bezüglich aller <span class="math inline">\(n_p\)</span> Parameter mit
möglichst wenigen Funktionsauswertungen zu finden. Diese Algorithmen
sind in Programmpaketen implementiert, die im Folgenden besprochen
werden. Sie übernehmen auch die zur Bestimmung der Unsicherheiten
notwendige Analyse des Verlaufs des Abstandmaßes in der Nähe des
Minimums und optional die grafische Darstellung der Ergebnisse.</p>
<p><strong>A2.3.1 Praktische Werkzeuge zur
Funktionsanpassung</strong></p>
<p>Ähnlich wie zur Darstellung von Messdaten gibt es fertige
<em>Python</em>-Programme, die Anpassungen an Daten ausführen und die
auf die Anforderungen in den physikalischen Praktika ausgerichtet sind.
Eines davon ist <em>kafe2go</em>, ein anderes <em>run_phyFit.py</em> aus
dem Paket PhyPraKit. Beide Programme nutzen (kompatible) Eingabedaten im
<em>yaml</em>-Format. <em>kafe2go</em> bietet mehr Möglichkeiten an als
das einfacher gehaltene <em>run_phyFit.py</em>.</p>
<p>Wir können die Eingabe aus der Beispieldatei von oben verwenden,
geben diesmal aber ein:</p>
<blockquote>
<p><code>python3 run_phyFit.py data.ydat</code></p>
</blockquote>
<p>oder</p>
<blockquote>
<p>kafe2go data.ydat` .</p>
</blockquote>
<p>Anstatt die Modellfunktion einfach nur grafisch darzustellen, wird
nun eine Anpassung durchgeführt, und in der Grafik und auf der
Textkonsole werden die besten Parameterwerte, deren Unsicherheiten und
die <span class="math inline">\(\chi^2\)</span>-Wahrscheinlichkeit
ausgegeben. Das Ergebnis ist in der Grafik unten dargestellt. Zusätzlich
wird noch ein schattiertes Band um die Funktion herum angezeigt, das den
Unsicherheitsbereich der Funktionsvorhersage wiedergibt und mittels
Fehlerfortpflanzung aus den Parameterunsicherheiten berechnet wird.</p>
<figure>
<img src="xyData_and_Model.png"
alt="Anpassung einer Exponentialfunktion an Messdaten mit run_phyFit.py" />
<figcaption aria-hidden="true">Anpassung einer Exponentialfunktion an
Messdaten mit <em>run_phyFit.py</em></figcaption>
</figure>
<p>Die Ergebnis mit <em>kafe2go</em> ist identisch, wie in der folgenden
Grafik gezeigt.</p>
<figure>
<img src="xyData_and_Model_kafe2.png"
alt="Anpassung einer Exponentialfunktion an Messdaten mit kafe2go" />
<figcaption aria-hidden="true">Anpassung einer Exponentialfunktion an
Messdaten mit <em>kafe2go</em></figcaption>
</figure>
<p><strong>A2.3.2 Komplexere Unsicherheiten</strong></p>
<p>Die große Stärke der Pakte <em>kafe2</em> und <em>phyFit</em> ist
deren Fähigkeit, mit komplexen Arten von Unsicherheiten umgehen zu
können. Solche Unsicherheiten betreffen die <span
class="math inline">\(x-\)</span> und/oder <span
class="math inline">\(y\)</span>-Werte, sie können unabhängig
voneinander oder korreliert, relativ oder absolut sein. Korrelierte
Unsicherheiten betreffen gegebenenfalls nur Untergruppen der Daten, z.B.
jeweils in gleichen Messbereichen eines Multimeters gemessene Ströme
oder Spannungen. Solche Szenarien lassen sich mit den Programmen korrekt
abbilden. Die Struktur der Unsicherheiten kann in <em>yaml</em>
abgebildet werden und sieht ganz allgemein so aus:</p>
<pre><code># general structure of error block
y_errors:  ( OR x_errors:)
- error_value: &lt;float&gt; OR &lt;[list of floats]&gt;
  correlated:  0. OR 1.
  relative:    false OR true
# possibly, add more kinds of uncertainties ...
- error_value ...
  ... </code></pre>
<p>Für <em>kafe2go</em> können von solchen Arten von Unsicherheiten
beliebig viele angegeben werden, die dann in einer gemeinsamen
Kovarianzmatrix aller Unsicherheiten zusammengefasst werden. In
<em>phyFit</em> wird momentan nur eine Angabe pro Unsicherheits-Typ
unterstützt.</p>
<p>Für relative Unsicherheiten, die auf den Modellwert bezogen werden,
oder für Unsicherheiten in <span
class="math inline">\(x\)</span>-Richtung, die unter Annahme des Modells
per Taylor-Entwicklung auf Unsicherheiten in <span
class="math inline">\(y\)</span>-Richtung transformiert werden, muss
diese Matrix in jedem Schritt der numerischen Optimierung neu berechnet
werden. Das ist zwar ein sehr aufwändiges Verfahren, auf modernen
Laptops aber überhaupt kein Problem. Einige auch komplexere Beispiele
sind im Verzeichnis <code>examples/</code> im Paket <em>PhyPraKit</em>
enthalten und können als Basis zur Lösung von eigenen
Anpassungsproblemen dienen.</p>
<p>Auch durch externe Kenntnisse eingeschränkte Parameter, wie in 3.5
beschrieben, können mit diesen Werkzeugen behandelt werden. Der
entsprechende Eintrag in der <em>yaml</em>-Datei sieht so aus:</p>
<pre><code>parameter_constraints:
  &lt;name1&gt;:
     value: &lt;v&gt;
     uncertainty &lt;u&gt;
  &lt;name2&gt;:
    ...</code></pre>
<p><strong>A2.3.3 Vereinfachte Behandlung komplexer
Unsicherheiten</strong></p>
<p>Viele der gängigen Programme zur Funktionsanpassung unterstützen
keine Unsicherheiten in <span class="math inline">\(x\)</span>-Richtung
oder korrelierte Unsicherheiten. Bei deren Verwendung muss dann auf
andere Verfahren zurückgegriffen werden, die lediglich einfache
Anpassungen nur unter Berücksichtigung der statistisch unabhängigen
Unsicherheiten in <span class="math inline">\(y\)</span>-Richtung
erfordern. Eventuell vorhandene weitere korrelierte Unsicherheiten,
relative Unsicherheiten und/oder Unsicherheiten in <span
class="math inline">\(x\)</span>-Richtung werden dann in nachfolgenden
Schritten hinzugefügt, indem man die Unsicherheiten in <span
class="math inline">\(y\)</span>-Richtung neu berechnet und die
Anpassung ggf. mehrfach wiederholt.</p>
<p>Solche Verfahren, wie sie unten kurz skizziert sind, waren auch
üblich, als Computer noch weniger leistungsfähig waren; sie werden auch
heute noch eingesetzt, wenn die Berechnung der Modellfunktion sehr
aufwändig ist.</p>
<p><strong>a) Behandlung von Unsicherheiten in <span
class="math inline">\(x\)</span>-Richtung</strong></p>
<p>Unsicherheiten der Datenpunkte bzgl. der Abszissenachse, d.h. der
<span class="math inline">\(x_i\)</span>, können folgendermaßen
berücksichtigt werden:</p>
<ol type="1">
<li>zunächst erfolgt eine Anpassung ohne Berücksichtigung der
Unsicherheiten der Abszissenwerte;</li>
<li>im einem zweiten Schritt werden diese dann mit Hilfe der ersten
Ableitungen <span class="math inline">\(f&#39;(x_i)\)</span> der im
ersten Schritt angepassten Funktion <span
class="math inline">\(f\)</span> in entsprechende Unsicherheiten in
<span class="math inline">\(y\)</span>-Richtung umgerechnet und
quadratisch zu den bereits vorhandenen Unsicherheiten in <span
class="math inline">\(y\)</span> addiert:<br />
<span class="math inline">\({\sigma_i}^2={\sigma_y}_i^2
\,+\,(f&#39;(x_i) \cdot {\sigma_x}_i)^2 \,\)</span>. Mit diesen
modifizierten Unsicherheiten wird die Residuensumme <span
class="math inline">\(S\)</span> minimiert.</li>
<li>Ein dritter Schritt, der der Vorgehensweise beim zweiten Schritt
entspricht, dient zur Verbesserung des Ergebnisses und zur
Fehlerkontrolle - der Wert <span class="math inline">\(S_0\)</span> am
Minimum darf sich vom zweiten zum dritten Schritt nicht signifikant
ändern, ansonsten muss nochmals iteriert werden.</li>
</ol>
<p><strong>b) Behandlung von Parametern mit externen
Einschränkungen</strong></p>
<p>Modellparameter, die durch externes Wissen im Rahmen ihrer
(gaußförmigen) Unsicherheiten eingeschränkt sind, lassen auch mit einem
Anpassungswerkzeug ohne die Möglichkeit zur Berücksichtigung von
Constraints (s. 3.5) behandeln, indem man Anpassungen mit jeweils um
<span class="math inline">\(\pm\sigma_{p_k}\)</span> veränderten Werten
des betreffenden Parameters <span class="math inline">\(p_k\)</span>
durchführt. Dabei verändern sich natürlich die Werte der angepassten
Parameter um <span class="math inline">\(\Delta_j^\pm\)</span>. Um
symmetrische Unsicherheiten zu erhalten, mittelt man beide Werte und
erhält so den Wert der systematischen Unsicherheit <span
class="math inline">\(\Delta_j = (\Delta_j^+ + \Delta_j^-)/2\)</span>,
den man quadratisch zur ursprünglichen Parameterunsicherheit <span
class="math inline">\(\sigma_j^0\)</span> addiert:</p>
<p><span class="math inline">\({\sigma_{a_j}}^2 = {\sigma^0_{a_j}}^2 +
\Delta_j^2\,\)</span>.</p>
<p><strong>c) Behandlung von korrelierten Unsicherheiten</strong></p>
<p>Korrelierte Unsicherheiten <span
class="math inline">\(\sigma_i^c\)</span> der Datenpunkte können
berücksichtigt werden, indem man sie in der Anpassung zunächst
vernachlässigt und in vor einer weiteren Anpassung zu den Datenpunkten
addiert bzw. davon subtrahiert:</p>
<p><span class="math inline">\(y_i&#39; = y_i \pm \sigma_i^c\,\)</span>
bzw.</p>
<p><span class="math inline">\(x_i&#39; = x_i \pm \sigma_i^c\,\)</span>
im Fall von Unsicherheiten in <span
class="math inline">\(x\)</span>-Richtung.</p>
<p>Die nach wiederholten Anpassungen gemittelten Änderungen <span
class="math inline">\(\Delta_j\)</span> der interessierenden Parameter
<span class="math inline">\(a_j\)</span> addiert man wie im Fall b)
quadratisch zu den ursprünglichen Parameterunsicherheiten <span
class="math inline">\(\sigma_{a_j}\)</span>.</p>
<p>Wenn das verwendete Anpassungswerkzeug die Berücksichtigung
eingeschränkter Parameter erlaubt, kann man korrelierte Unsicherheiten
auch als Verschiebung <span class="math inline">\(o=0\)</span> bzw. als
als Skalierungsfaktor <span class="math inline">\(s=1\)</span> mit
Unsicherheiten <span class="math inline">\(\sigma_o\)</span> bzw. <span
class="math inline">\(\sigma_s\)</span> auffassen und im Modell <span
class="math inline">\(f(x_i)\)</span> durch <span
class="math inline">\(o + s \cdot f(x_i)\)</span> bzw. <span
class="math inline">\(f(o + s \cdot x_i)\)</span> im Fall von
Unsicherheiten in <span class="math inline">\(x\)</span>-Richtung
ersetzen. Die Unsicherheiten bzgl. Verschiebung oder Skalierung werden
so korrekt auf die Parameterunsicherheiten propagiert.</p>
<p><strong>d) Behandlung von relativen Unsicherheiten</strong></p>
<p>Wenn Unsicherheiten von den Messwerten selbst oder von den
Modellparametern abhängen, also z.B. auf den wahren Wert bezogenen
relative Unsicherheiten oder auch statistische Unsicherheiten in
Zählexperimenten, sind die Grenzen der Methode der kleinsten
Fehlerquadrate erreicht. In solchen Fällen müssen zur Vermeidung von
Verzerrungen die Unsicherheiten in jedem Schritt der Minimierung neu auf
Grund der jeweils aktuellen Parameterwerte berechnet werden.</p>
<p>Man kann relative Unsicherheiten zunächst auf die gemessenen Werte
beziehen und eine erste Anpassung durchführen. Dann werden für einen
zweiten Schritt die Unsicherheiten auf Grund der nun näherungsweise
bekannten Modellwerte erneut berechnet und die endgültige Anpassung
durchgeführt, aus der man die finalen Parameterunsicherheiten
entnimmt.</p>
<h2 id="a3-arbeiten-mit-jupyter-notebooks">A3: Arbeiten mit <em>Jupyter
Notebooks</em></h2>
<p><a name="AppendixA3"></a></p>
<p>Das quelloffene Projekt <a
href="https://jupyter.org/"><em>Jupyter</em></a> bietet eine
Web-basierte interaktive Umgebung für wissenschaftliche Berechnungen und
Datenauswertung Die zu Grunde liegenden Dateien sind sogenannte
„Notebooks“, die sowohl formatierten Text als auch Programmcode u.a. in
der Sprache <em>Python</em> und die entsprechende Programmausgabe in
Form von Text und Grafiken in einem einzigen Dokument vom Typ
<code>.ipynb</code> speichern.</p>
<p>Grundlage der Texteingabe und -formatierung bildet das oben schon
erwähnte, von Menschen und Maschinen gut zu lesende
<em>Markdown</em>-Format. Bei diesem modernen Konzept dient ein
beliebiger Web-Browser als grafisches Interface zu einem Jupyter-Server,
der entweder im Netzwerk oder auch lokal auf dem gleichen Computer
laufen kann. Die Installation eines lokalen <em>Jupyter</em>-Sververs
als Möglichkeit einer Umgebung zur Datenauswertung wurde bereits oben in
Kap. 4. besprochen. Damit lassen sich die Vorgaben zur Dokumentation von
Messwerten und der damit durchgeführten Analysen inklusive des
verwendeten Programmcodes vollständig nachvollziehbar und reproduzierbar
dokumentieren.</p>
<p>Die Fakultät für Physik betreibt einen Jupyter-Server, der
Studierenden zur Verfügung steht. Informationen dazu findet man in den
einführenden <a
href="https://etp.kit.edu/~quast/jupyter/jupyterTutorial.html">[Tutorials
zur Nutzung von Jupyter Notebooks]</a>. Dieser Server ermöglicht
Datenauswertungen ohne die Notwendigkeit der Installation eigener
Software. Eine <em>Jupyter</em> Testumgebung auch ohne Zugang zum Server
der Fakultät wird auf der <a
href="https://etpwww.etp.kit.edu/~quast/">[Homepage des Autors]</a>
bereit gestellt. Dort finden sich auch eine Reihe an grundlegenden und
weiter führenden Tutorials zur Anwendung der <em>Jupyter</em>-Umgebung,
zur Einführung in die Grundlagen der Statistik und Fehlerrechnung sowie
zu fortgeschritteneren Themen wie die Nutzung des Programmierinterfaces
von <em>kafe2</em>, zur Maximum-Likelihood-Methode und zum modernen
Datenverwaltungs- und -analyse-Werkzeug <em>pandas</em>.</p>
<p>Kenntnisse der Sprache <em>Python</em> und die sehr komfortable
<em>Jupyter</em>-Umgebung bilden heute die Grundlage für die
wissenschaftliche Datenauswertung in vielen Disziplinen. In den
Veranstaltungen zu den Grundlagen der Rechnernutzung und der
computergestützten Datenauswertung wurden <em>Jupyter Notebooks</em> als
Entwicklungsumgebung für <em>Python</em>-Programme bereits
eingeführt.<br />
Die gut strukturierte Oberfläche ist intuitiv erlernbar. In den Praktika
werden überdies Vorlagen bereit gestellt, die die Versuchsanleitungen
sowie notwendige Hilfsmittel wie Formeln, fertige Programme oder
auch<br />
Code-Fragmente schon enthalten.</p>
<h4
id="jupyter-notebook-mit-stand-alone-programmen-zur-datenauswertung"><em>Jupyter</em>-Notebook
mit stand-alone Programmen zur Datenauswertung</h4>
<p>An dieser Stelle möchten wir explizit auf das Jupyter-Notebook
<em>tutorial_StandAloneTools</em> aus dem Paket <em>PhyPraKit</em>
verweisen, das Sie im Verzeichnis <em>PhypraKit/ipynb_examples</em>
finden.</p>
<p>Es enthält einige Beispiele, die Darstellung und Auswertung von Daten
auch ohne eigenen Programmcode mit Hilfe der in <em>A1 c)</em>
beschriebenen Programme <em>plotData.py</em>, <em>kafe2go.py</em> oder
<em>run_phyFit.py</em> bewerkstelligen. Die Eingabedaten werden dazu in
Textdateien im ebenfalls oben beschriebenen <em>yaml</em>-Format bereit
gestellt. Als Namenskonvention wurden die Endungen <em>.ydat</em> für
Daten und <em>.yfit</em> für Eingabedateien gewählt.</p>
<p>Die in diesem Tutorial beschriebenen Methoden und Vorgehensweisen
bilden die Grundlage für die Datenauswertung und Dokumentation im
Physikalischen Anfängerpraktikum.</p>
<h2 id="a4-tipps-für-ms-windows">A4: Tipps für MS Windows</h2>
<p><a name="AppendixA4"></a></p>
<h3 id="a4.1.-wichtige-befehle-für-die-kommandozeile">A4.1. Wichtige
Befehle für die Kommandozeile</h3>
<p><em>Anmerkung</em>: Bitte die <em>Windows Konsole</em> und nicht die
neuere <em>PowerShell</em> benutzten, da letztere ggf. einige
zusätzliche Konfigurationen erfordert, um die hier vorausgesetzte
Verhaltensweise zu erzeugen!</p>
<p><em>Tipp</em>: Starten Sie am Besten die <em>Windows Konsole</em> und
probieren Sie die Bespiele gleich aus !</p>
<p>Befehle für Windows Eingabeaufforderung:</p>
<ul>
<li><code>cd &lt;Ordnerpfad&gt;</code> (= change directory): in anderes
Verzeichnis wechseln</li>
<li><code>cd ..</code> ins Verzeichnis darüber wechseln</li>
<li><code>dir</code> zeigt eine Liste der Dateien und Ordner</li>
<li><code>move &lt;Quelldatei&gt; &lt;Zielordner&gt;</code> verschieben
von Dateien</li>
<li><code>copy &lt;Quelldatei(-Pfad)&gt; &lt;Zielordner&gt;</code>
Kopieren von Dateien</li>
<li><code>md &lt;Ordnername&gt;</code> Erzeugen eines neuen Ordners</li>
<li><code>rd &lt;Ordnername/-pfad&gt;</code> Löschen eines (leeren)
Ordners</li>
<li><code>type &lt;Dateiname&gt;</code> Ausgabe einer Text-Datei auf
Bildschirm</li>
</ul>
<p>Windows-Programme lassen sich ebenfalls bequem von der Kommandozeile
aus starten:</p>
<ul>
<li><code>notepad &lt;Dateiname&gt;</code> startet den Texteditor</li>
<li><code>ìdle &lt;Dateiname&gt;</code> startet die einfache
<em>Python</em>-Umgebung <em>idle</em></li>
<li><code>pip install &lt;Paketname&gt;</code> installiert ein
<em>Python</em>-Paket</li>
<li><code>pip install --upgrade &lt;Paketname&gt;</code> dient zu
Aktualisierung von <em>Python</em>-Paketen</li>
<li><code>pip install --upgrade --pre &lt;Paketname&gt;</code>
berücksichtigt auch Vorabversionen bei der Aktualisierung</li>
<li><code>&lt;name&gt;.py [parameter]</code> startet ein
<em>Python</em>-Programm mit dem angegebenen Parameter, wenn die
Verknüpfung von Dateien mit der Endung <code>.py</code> mit
<em>Python.exe</em> hergestellt und sich das <em>Python</em>-Skript im
Windows-Suchpfad für ausführbare Programme befindet (s. unten)</li>
<li><code>pdflatex &lt;name&gt;.tex</code> erzeugt eine Ausgabedatei im
<em>pdf</em>-Format aus einer <em>LaTeX</em>-Datei</li>
<li><code>pandoc &lt;name.md&gt; -o &lt;output-name&gt;.pdf</code>
erzeugt eine Ausgabedatei im <em>pdf</em>-Format aus einer Datei im
Markdown-Format</li>
</ul>
<h3 id="a4.2.-installation-von-python-unter-windows">A4.2. Installation
von <em>Python</em> unter Windows</h3>
<p>Am besten installiert man eine vollständige <em>Python</em>-Umgebung
unter Windows, wie im folgenden beschrieben. Sollte das nicht möglich
bzw. nicht gewünscht sein, lassen sich wesentliche Funktionen mit Hilfe
der oben schon erwähnten stand-alone Programme durchführe, die für das
Betriebssystem Windows auch als ausführbare Programme (“exe-Dateien”)
vorliegen. Sollten Sie diesen Weg vorziehen, können Sie gleich in
Abschnitt A.4.3 weiter lesen.</p>
<p><em>Python</em> für Windows installiert man am besten direkt von der
<a href="https://www.python.org">Homepage der Python Foundation</a>. Die
jeweils aktuellste sowie auch ältere Versionen können dort als
Installationspaket für Windows herunter geladen werden. Für diese
Dokumentation wurde <code>Python 3.10.5</code> verwendet und auf den
Versionen Windows 10 und 11 getestet.</p>
<p>Zur Installation wählen Sie die gewünschte <em>Python</em>-Version
(3.10.x) aus und laden Sie den passenden Windows Installer herunter -
bei den meisten modernen Systemen ist das <em>Windows Installer
(64-bit)</em>. Starten Sie nach dem Download den Installer und beachten
Sie die angebotenen Optionen - idealerweise sollten alle Komponenten im
Fenster ausgewählt werden, insbesondere auch der
<code>py launcher</code>, der als ausführbare Datei im Verzeichnis
<code>C:\Windows\</code>installiert wird. Im zweiten Fenster des
Installationsprogramms gibt es weitere Optionen. Man kann
<em>Python</em> systemweit für alle Nutzer installieren, wenn man
Administrator-Rechte auf dem System hat. Ansonsten werden die Daten für
die Installation im Nutzerbereich als Unterordner im Verzeichnis
<code>C:\Users\&lt;name&gt;\AppData</code> abgelegt. Die Option
<em>Asscociate files with Python</em> sollte ebenfalls ausgewählt werden
- dann werden Dateien mit der Endung <code>.py</code> automatisch mit
der richtigen Anwendung (<em>Python</em>) gestartet. Auch die Option
<code>Add Python to environment variables</code> ist empfehlenswert,
damit alle im Unterverzeichnis <code>\Scripts</code> des
<em>Python</em>-Installationsverzeichnisses abgelegten Programme ohne
Pfadangabe ausgeführt werden können.<br />
Als letztes kann noch das Installationsverzeichnis ausgewählt
werden;<br />
hier empfiehlt es sich, einen einfachen Pfadnamen auszuwählen, damit man
später die Python-Installation wiederfindet und ggf. Desktop-Icons für
häufig genutzte Programme anlegen kann.</p>
<p>Die Verknüpfung von <em>Python</em>-Programmen mit der passenden
Anwendung kann auch noch nach der Installation erfolgen. Dazu mit der
rechten Maus auf eine <em>Python-Datei</em> klicken und “Öffnen mit”
anklicken, dann die Anwendung <code>C:\Windows\py.exe</code> auswählen.
Nun können <em>Python</em>-Programme durch Anklicken oder auch auf der
Kommandozeile durch Angabe ihres Namens ausgeführt werden. Ebenfalls
angegebene Parameter, wie Ein- oder Ausgabedateien oder Optionen, werden
dabei übernommen und an das <em>Python</em>-Programm übergeben.</p>
<p>Wenn <em>Python</em> systemweit installiert wurde, sollten alle mit
<em>pip</em> nachinstallierten Pakete ebenfalls mit
Administrator-Rechten installiert werden, damit die sie in den korrekten
Unterverzeichnissen der <em>Python</em>-Installation gespeichert
werden.</p>
<h3 id="a4.3-stand-alone-programme-zur-datenauswertung">A4.3 Stand-alone
Programme zur Datenauswertung</h3>
<p>Direkt unter MS-Windows ausführbare Version der in A1.c beschriebenen
<a
href="https://www.etp.kit.edu/~quast/PhyPraKit/PhyPraExe.html">stand-alone
Programme</a> sind in der gepackten Datei <a
href="https://www.etp.kit.edu/~quast/PhyPraKit/PhyPraExe%20.zip">PhyPraExe.zip</a>
enthalten. Diese Dateien im Windows “<em>exe</em>-Format” benötigen
keine <em>Python</em>-Installation, weil alle notwendigen Bibliotheken
und Konfigurationsdateien bereits enthalten sind. Zur Installation
einfach alle Dateien in ein eigenes Verzeichnis (z.B. PhyPraExe)
entpacken, das Sie, wie im nächsten Abschnitt beschrieben, in den
Suchpfad für ausführbare Programm aufnehmen sollten.</p>
<p>Die einzelnen Programme startet man am besten in einem
Terminal-Fenster von der Kommandozeile aus, weil dann auch Parameter und
Optionen angegeben werden können. Hilfe erhalten Sie jeweils durch
Eingabe von <code>&lt;programm_name&gt; --help</code>.</p>
<h3
id="a4.4.-eigenen-bereich-in-den-pfad-der-ausführbaren-programme-aufnehmen.">A4.4.
Eigenen Bereich in den Pfad der ausführbaren Programme aufnehmen.</h3>
<p>Für Aufgaben in der Datenauswertung werden meist eine ganze Reihe von
Programmen benötigt, die Daten aus einem Arbeitsverzeichnis lesen oder
neue darin erzeugen. In Windows wird eine Liste von Pfaden verwaltet, in
denen nach den Namen von Programmen gesucht wird. Bei der Installation
werden diese Pfade dort üblicherweise eingetragen; allerdings gilt dies
nicht für <em>Python</em>-Programme, die auf anderem Weg kopiert werden,
z.B. die oben angeführten Werkzeuge für grafische Darstellungen oder zur
Funktionsanpassung. Damit diese Programme nur mit ihrem Namen ohne
Angabe des zum Teil langen Verzeichnispfades ihres Speicherorts
aufgerufen werden können, müssen sie in einem Verzeichnis liegen, das
sich im Suchpfad befindet. Dazu sollte ein entsprechendes Verzeichnis
angelegt, in den Suchpfad eingetragen und dann die benötigten Programme
(bzw. Links darauf, siehe unten) dort hin kopiert werden.</p>
<p>Dazu im Verzeichnis des Nutzers ein neues Verzeichnis für die
Hilfsprogramme erzeugen, z.B. mit dem Namen <code>Programme</code>:</p>
<pre><code>   &gt; mkdir C:\Users\&lt;name&gt;\Programme</code></pre>
<p>Dann auf der Kommandozeile das neue Verzeichnis in die Liste der für
ausführbare Programme durchsuchten Pfade eingeben:</p>
<pre><code>   &gt; setx PATH &quot;%PATH%;C:\Users\&lt;name&gt;\Programme&quot; </code></pre>
<p>Nun das Fenster schließen und die Eingabeaufforderung neu starten.
Mit</p>
<pre><code>   &gt; path</code></pre>
<p>den aktuellen Suchpfad ausgeben und überprüfen, ob alles korrekt
übernommen wurde.</p>
<p><em>Python</em>-Programme oder andere <em>.exe</em>-Dateien, die in
das neu angelegte Verzeichnis kopiert wurden, können nun direkt mit
ihrem Namen ohne Pfad-Angabe aufgerufen werden.</p>
<h3 id="a4.5.-link-für-dateien-erzeugen">A4.5. Link für Dateien
erzeugen</h3>
<p>Programmdateien sind oft sehr groß, und daher legt man häufig nur
einen Verweis, einen “Link” anstelle einer Kopie an. In Windows gibt es
dazu den sog. Hardlink, den man nur über die Kommandozeile erzeugen
kann:</p>
<pre><code>   &gt; mklink /h &lt;Verknüpfung&gt; &lt;Ziel&gt;</code></pre>
<p>Wenn man also im gemeinsamen Bereich aller Hilfsprogramme solche
Hardlinks auf häufig benötigte Programme anlegt, kann man sie von jedem
Verzeichnis aus durch Eingabe ihres Namens starten.</p>
<p>Mit Eingabe von</p>
<pre><code>   &gt; mklink /j &lt;Verknüpfung&gt; &lt;Zielverzeichnis&gt;</code></pre>
<p>kann man auch auf ein ganzes Verzeichnis verweisen. Dies ist
nützlich, um ggf. lange Pfade abzukürzen.</p>
<p>Mit dem Befehl</p>
<pre><code>   &gt; del &lt;Ziel&gt; </code></pre>
<p>kann man solche Links auch wieder löschen, ohne dabei die
Originaldaten zu beeinflussen.</p>
<h3 id="a4.6-arbeiten-mit-origin">A4.6 Arbeiten mit <em>Origin</em></h3>
<p><a href="https://www.originlab.com">[<em>Origin</em>]</a> ist eine
weit verbreitete kommerzielle Software ausschließlich für das
Betriebssystem Microsoft Windows zur Visualisierung und Analyse von
Daten, das nur gegen Lizenzgebühr genutzt werden kann. <em>Origin</em>
ist im Softwarekatalog für Akademische Forschung und Lehre enthalten und
für KIT-Angehörige im <a
href="https://rzunika.asknet.de/cgi-bin/product/P14315">[Softwareshop
des KIT SCC]</a> kostenlos verfügbar.</p>
<p><em>Origin</em> zeichnet sich durch ein an Microsoft Excel
angelehntes Bedienkonzept aus, das Datenerfassung ähnlich wie in
gängigen Programmen zur Tabellenkalkulation ermöglicht. Es gibt eine
sehr umfangreiche Auswahl an grafischen Darstellungsmöglichkeiten und
Analysewerkzeugen, zu denen auch die Anpassung beliebiger Funktionen an
Messdaten mit Unsicherheiten gehört. <em>Origin</em> deckt eine große
Palette an Anforderungen aus verschiedenen Wissenschaftsbereichen ab,
und daher ist die Auswahl der für physikalische Auswertungen sinnvollen
Einstellungen und üblichen Darstellungsformen nicht ganz einfach. In der
<a
href="https://www.physik.kit.edu/downloads/Lehramt_Dokumente/Anleitungen_Praktikum/Origin_Kurzskript.pdf">[Kurzanleitung
zu Verwendung von Origin für das Praktikum für Lehramt]</a> sind die
notwendigen Informationen zusammengestellt.</p>
</body>
</html>
